/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ AiOpbg ]
 *
 *	RHG
 *	  2002.05.25		svȉʍĕ`ʒm}悤ɂ
 *	  2015.02.06		pbgWX^EChEV݂ɔACjVG[^ROM
 *						LȂƂɂ͋IɕύXʒm𔭍s悤ɕύX
 *						(ꂪȂVC++ŃRpCۂɕs)
 */

#if XM7_VER >= 2

#include <string.h>
#include "xm7.h"
#include "device.h"
#include "apalet.h"
#include "display.h"
#include "subctrl.h"

/*
 *	O[o [N
 */
WORD apalet_no;							/* Ipbgԍ */
BYTE apalet_b[4096];					/* Bx(0-15) */
BYTE apalet_r[4096];					/* Rx(0-15) */
BYTE apalet_g[4096];					/* Gx(0-15) */

/*
 *	AiOpbg
 *	
 */
BOOL FASTCALL apalet_init(void)
{
	memset(apalet_b, 0, sizeof(apalet_b));
	memset(apalet_r, 0, sizeof(apalet_r));
	memset(apalet_g, 0, sizeof(apalet_g));

	return TRUE;
}

/*
 *	AiOpbg
 *	N[Abv
 */
void FASTCALL apalet_cleanup(void)
{
}

/*
 *	AiOpbg
 *	Zbg
 */
void FASTCALL apalet_reset(void)
{
	apalet_no = 0;
}

/*-[ }bvhI/O ]----------------------------------------------------*/

/*
 *	AiOpbg
 *	PoCgǂݏo
 */
BOOL FASTCALL apalet_readb(WORD addr, BYTE *dat)
{
	/* o[W`FbN */
	if (fm7_ver < 2) {
		return FALSE;
	}

	/* AhX`FbN */
	if ((addr >= 0xfd30) && (addr <= 0xfd34)) {
#if XM7_VER >= 3
		/* FM77AV͓ǂݏołȂ */
		if (fm7_ver < 3) {
			*dat = 0xff;
			return TRUE;
		}

		/* FM77AV40EXRGBx̂ݓǂݏo\ */
		switch (addr) {
			/* pbgԍ(ǂݏołȂ) */
			case 0xfd30:
				*dat = 0xff;
				return TRUE;

			/* pbgԍ(ǂݏołȂ) */
			case 0xfd31:
				*dat = 0xff;
				return TRUE;

			/* Bx */
			case 0xfd32:
				*dat = (BYTE)(0xf0 | (apalet_b[apalet_no] & 0x0f));
				return TRUE;

			/* Rx */
			case 0xfd33:
				*dat = (BYTE)(0xf0 | (apalet_r[apalet_no] & 0x0f));
				return TRUE;

			/* Gx */
			case 0xfd34:
				*dat = (BYTE)(0xf0 | (apalet_g[apalet_no] & 0x0f));
				return TRUE;
		}
#else
		/* FM77AV͓ǂݏołȂ */
		*dat = 0xff;
		return TRUE;
#endif
	}

	return FALSE;
}

/*
 *	AiOpbg
 *	PoCg
 */
BOOL FASTCALL apalet_writeb(WORD addr, BYTE dat)
{
	/* o[W`FbN */
	if (fm7_ver < 2) {
		return FALSE;
	}

	switch (addr) {
		/* pbgԍ */
		case 0xfd30:
			apalet_no &= (WORD)0xff;
			apalet_no |= (WORD)((dat & 0x0f) << 8);
			return TRUE;

		/* pbgԍ */
		case 0xfd31:
			apalet_no &= (WORD)(0xf00);
			apalet_no |= (WORD)(dat);
			return TRUE;

		/* Bx */
		case 0xfd32:
			if (apalet_b[apalet_no] != (dat & 0x0f)) {
				apalet_b[apalet_no] = (BYTE)(dat & 0x0f);
				/* ʒm */
				apalet_notify();
			}
			return TRUE;

		/* Rx */
		case 0xfd33:
			if (apalet_r[apalet_no] != (dat & 0x0f)) {
				apalet_r[apalet_no] = (BYTE)(dat & 0x0f);
				/* ʒm */
				apalet_notify();
			}
			return TRUE;

		/* Gx */
		case 0xfd34:
			if (apalet_g[apalet_no] != (dat & 0x0f)) {
				apalet_g[apalet_no] = (BYTE)(dat & 0x0f);
				/* ʒm */
				apalet_notify();
			}
			return TRUE;
	}

	return FALSE;
}

/*-[ t@CI/O ]----------------------------------------------------------*/

/*
 *	AiOpbg
 *	Z[u
 */
BOOL FASTCALL apalet_save(int fileh)
{
	if (!file_word_write(fileh, apalet_no)) {
		return FALSE;
	}
	if (!file_write(fileh, apalet_b, sizeof(apalet_b))) {
		return FALSE;
	}
	if (!file_write(fileh, apalet_r, sizeof(apalet_r))) {
		return FALSE;
	}
	if (!file_write(fileh, apalet_g, sizeof(apalet_g))) {
		return FALSE;
	}

	return TRUE;
}

/*
 *	AiOpbg
 *	[h
 */
BOOL FASTCALL apalet_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	if (!file_word_read(fileh, &apalet_no)) {
		return FALSE;
	}
	if (!file_read(fileh, apalet_b, sizeof(apalet_b))) {
		return FALSE;
	}
	if (!file_read(fileh, apalet_r, sizeof(apalet_r))) {
		return FALSE;
	}
	if (!file_read(fileh, apalet_g, sizeof(apalet_g))) {
		return FALSE;
	}

	return TRUE;
}

#endif	/* XM7_VER >= 2 */
