/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ ou Rg[ (32KBp) ]
 */

#ifndef _bubble_h_
#define _bubble_h_

#if XM7_VER == 1 && defined(BUBBLE)

/*
 *	萔`
 */
#define BMC_UNITS_32		2			/* 32KBT|[gjbg */
#define BMC_MEDIAS			16			/* B77t@CɊ܂܂ő{ */

#define BMC_ST_BUSY			0x01		/* BUSY */
#define BMC_ST_ERROR		0x02		/* ERROR ANALYSIS */
#define BMC_ST_WRITEP		0x04		/* ݕی */
#define BMC_ST_READY		0x08		/* fBA} */
#define BMC_ST_NONE			0x10		/* '1' */
#define BMC_ST_RDA			0x20		/* CAN READ */
#define BMC_ST_TDRA			0x40		/* CAN WRITE */
#define BMC_ST_CME			0x80		/* COMMAND END */

#define BMC_ES_UNDEF		0x01		/* UNDEFINED COMMAND ERROR */
#define BMC_ES_NOMAKER		0x02		/* NO MARKER */
#define BMC_ES_MANYBAD		0x04		/* MANY BAD LOOP */
#define BMC_ES_TRANSFER		0x08		/* TRANSFER MISSING */
#define BMC_ES_CRCERR		0x10		/* CRC ERROR */
#define BMC_ES_PAGEOVER		0x20		/* PAGE ADDRESS OVER ERROR */
#define BMC_ES_NONE			0x40		/* ---- */
#define BMC_ES_EJECT		0x80		/* EJECT ERROR */

#define BMC_TYPE_NOTREADY	0			/* t@CȂ */
#define BMC_TYPE_32			1			/* 32KBt@C}Eg */
#define BMC_TYPE_128		2			/* 128KBt@C}Eg(dash) */
#define BMC_TYPE_B77		3			/* B77t@C}Eg */

#define BMC_ACCESS_READY	0			/* ANZXȂ */
#define BMC_ACCESS_READ		1			/* ǂݍ݌nANZX */
#define BMC_ACCESS_WRITE	2			/* ݌nANZX */
#define BMC_ACCESS_NOTREADY	3			/* jbg̏łĂȂ */
#define BMC_ACCESS_TEJECT	4			/* jbgꎞCWFNg */
#define BMC_LOST_TIME		300			/* waitLOST DATA܂ł̎ */

#define BMC_PSIZE_32		0x20		/* 32KBy[WTCY */
#define BMC_MAXADDR_32		0x03ff		/* 32KBŏIy[WAhX */

#ifdef __cplusplus
extern "C" {
#endif
#if !defined(XM7PURE) || defined(BUBBLE)
/*
 *	vGg
 */
BOOL FASTCALL bmc_init(void);
										/*  */
void FASTCALL bmc_cleanup(void);
										/* N[Abv */
void FASTCALL bmc_reset(void);
										/* Zbg */
BOOL FASTCALL bmc_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL bmc_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL bmc_save(int fileh);
										/* Z[u */
BOOL FASTCALL bmc_load(int fileh, int ver);
										/* [h */
int FASTCALL bmc_setfile(int unit, char *fname);
										/* Zbg */
BOOL FASTCALL bmc_setmedia(int unit, int index);
										/* fBAԍݒ */
BOOL FASTCALL bmc_setwritep(int unit, BOOL writep);
										/* CgveNgw */

/*
 *	v[N
 */
extern BYTE bmc_datareg;
										/* $FD10   f[^WX^ */
extern BYTE bmc_command;
										/* $FD11   R}hWX^ */
extern BYTE bmc_status;
										/* $FD12   Xe[^XWX^ */
extern BYTE bmc_errorreg;
										/* $FD13   G[Xe[^XWX^ */
extern WORD bmc_pagereg;
										/* $FD14-5 y[WWX^ */
extern WORD bmc_countreg;
										/* $FD16-7 y[WJEgWX^ */

extern WORD bmc_totalcnt;
										/* g[^JE^ */
extern WORD bmc_nowcnt;
										/* JgJE^ */
extern BYTE bmc_unit;
										/* jbg */
extern BYTE bmc_ready[BMC_UNITS_32];
										/* fB */
extern BOOL bmc_teject[BMC_UNITS_32];
										/* ꎞCWFNg */
extern BOOL bmc_writep[BMC_UNITS_32];
										/* ݋֎~ */

extern char bmc_fname[BMC_UNITS_32][256+1];
										/* t@C */
extern char bmc_name[BMC_UNITS_32][BMC_MEDIAS][17];
										/* fBAƂ̖O */
extern BOOL bmc_fwritep[BMC_UNITS_32];
										/* ݋֎~(t@CP) */
extern BYTE bmc_header[BMC_UNITS_32][0x20];
										/* B77t@Cwb_ */
extern BYTE bmc_medias[BMC_UNITS_32];
										/* fBA */
extern BYTE bmc_media[BMC_UNITS_32];
										/* fBAZNg */
extern BYTE bmc_access[BMC_UNITS_32];
										/* ANZXLED */
extern BOOL bmc_enable;
										/* LEtO */
extern BOOL bmc_use;
										/* gptO */
#endif	/* !defined(XM7PURE) */

/*
 *	vGg (Xe[gt@C֌W)
 */
BOOL FASTCALL bmc_save(int fileh);
										/* Z[u */
BOOL FASTCALL bmc_load(int fileh, int ver);
										/* [h */

#ifdef __cplusplus
}
#endif

#endif	/* XM7_VER == 1 */

#endif	/* _bubble_h_ */
