/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2020 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2020 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ fBXvC ]
 *
 *	RHG
 *	  2001.07.23()	ʃ[ḧύX
 *	  2001.07.27		svȍĕ`̂߂ɑxቺC
 *	  2001.07.29		400C[h̃|C^ݒlC
 *	  2001.11.10		400C[h̃XN[C()
 *	  2001.11.19		VRAM̔zu@ɍ킹ƂɔύX(^^;
 *	  2001.11.25		n[hEFAEBhE̋ύX
 *	  2002.03.06		FM-7[h$D430ւ݂̏LɂȂC
 *	  2002.05.25		V2RpCɕsvȃR[h𐶐Ȃ悤ɏC
 *						4096FE26F̃XN[𓝍
 *	  2002.11.01		Cmemcpy400lǉ
 *	  2003.02.20		200C[h400C/4096F[hŕʂɂȂĂ
 *						VRAM\|C^(\E)𓝍
 *	  2003.03.05		ʃ[h200C8F[hȊȌԂŃTuj^
 *						؂ւƉʂȂ邱ƂC
 *	  2003.03.29		n[hEFAEBhEWX^ݕύX
 *						n[hEFAEBhEWX^̗LrbgύX
 *	  2003.06.02		CLR߂BUSYtO𗎂ƂƃfbhbNɑ
 *						
 *	  2003.11.20		XM7 V1.1Ή
 *						FM-7[hNMI}XN\C
 *						
 *	  2003.11.21		$FD04 bit5(ROMڑ̐؂芷@\)ɑΉ
 *	  2004.01.24		ZbgɒOVRAMItZbgɂăXN[
 *						s悤ɕύX
 *	  2004.11.20		vsync_notify̌Ăяo\Ԃ̏IɕύX
 *	  2010.01.13		TrueColor̋Pxϊe[uǉ
 *	  2010.12.09		FM77AV40/20n璊oJIS83ROMf[^ɂ
 *						āAFM-77[hJIS78G~[Vǉ
 *	  2011.04.09		FM-77[hŊROMAhXvZԈĂ̂C
 *	  2011.05.30		샂[hʂJIS78tHgJIS83tHg̓
 *						ł悤ύX
 *	  2012.05.29		Xe[g[h400CJ[h݃tOƉʃ[
 *						h̐`FbNs悤ɂ
 *	  2012.08.15		n[hEFAEBhEWX^̏FALSEԂ
 *						C
 *	  2013.02.12		X^_OɑΉ
 */

#include <stdlib.h>
#include <string.h>
#include "xm7.h"
#include "display.h"
#include "subctrl.h"
#include "device.h"
#include "ttlpalet.h"
#include "multipag.h"
#include "mainetc.h"
#include "aluline.h"
#include "keyboard.h"
#include "kanji.h"
#include "event.h"

/*
 *	O[o [N
 */
BOOL crt_flag;							/* CRT ONtO */
BOOL vrama_flag;						/* VRAMANZXtO */
WORD vram_offset[2];					/* VRAMItZbgWX^ */
WORD crtc_offset[2];					/* CRTCItZbg */
BOOL vram_offset_flag;					/* gVRAMItZbgWX^tO */
BOOL vsync_flag;						/* VSYNCtO */
BOOL draw_aftervsync;					/* ʕ`ʒm^C~O */
int now_raster;							/* ݃X^ʒu */
BOOL magus_patch;						/* MAGUS΍􏈗tO */

BOOL blank_flag;						/* uLOtO */
#if XM7_VER >= 2
BOOL subnmi_flag;						/* TuNMICl[utO */

BYTE vram_active;						/* ANeBuy[W */
BYTE *vram_aptr;						/* VRAMANeBv|C^ */
BYTE vram_display;						/* \y[W */
BYTE *vram_dptr;						/* VRAM\|C^ */
#endif


#if XM7_VER >= 3
/* FM77AV40 */
BYTE screen_mode;						/* ʃ[h */
BYTE subram_vrambank;					/* ANeBuy[W(400line/26F) */

WORD sub_kanji_addr;					/* ROMAhX */
BOOL sub_kanji_bank;					/* ROMI */

/* FM77AV40EX */
WORD window_x1, window_dx1;				/* EBhE X1 */
WORD window_y1, window_dy1;				/* EBhE Y1 */
WORD window_x2, window_dx2;				/* EBhE X2 */
WORD window_y2, window_dy2;				/* EBhE Y2 */
BOOL window_open;						/* EChEI[vtO */

BYTE block_active;						/* ANeBuubN */
BYTE *vram_ablk;						/* ANeBuubN|C^ */
BYTE block_display;						/* \ubN */
BYTE *vram_bdptr;						/* \ubN|C^ */
BYTE *vram_dblk;						/* \ubN|C^2 */
BYTE *vram_bdblk;						/* \ubN|C^2 */
#endif

#if XM7_VER == 1 && defined(L4CARD)
BOOL width40_flag;						/* width flag */
BOOL cursor_lsb;						/* J[\AhXLSB */
BOOL enable_400line;					/* 400C[htO */
BOOL workram_select;					/* [NRAMZNgtO */
WORD sub_kanji_addr;					/* ROMAhX */

BYTE crtc_register[0x20];				/* CRTCWX^ */
BYTE crtc_regnum;						/* CRTCWX^ԍWX^ */

WORD text_start_addr;					/* eLXgX^[gAhX */
WORD cursor_addr;						/* J[\AhX */
BOOL text_blink;						/* eLXguN */
BOOL cursor_blink;						/* J[\uN */
#endif

/*
 *	X^eBbN [N
 */
static BYTE *vram_buf;					/* VRAMXN[obt@ */
static BYTE vram_offset_count[2];		/* VRAMItZbgݒJE^ */
static WORD blank_count;				/* uNJE^ */
#if XM7_VER == 1 && defined(L4CARD)
static DWORD text_scroll_count;			/* TVRAMItZbgݒJE^ */
static DWORD text_cursor_count;			/* TVRAMJ[\ʒuݒJE^ */
static BYTE text_blink_count;			/* eLXguNJE^ */
static BYTE cursor_blink_count;			/* J[\uNJE^ */
#endif

/*
 *	vg^Cv錾
 */
static BOOL FASTCALL subcpu_event(void); /* TuCPU^C}Cxg */
static BOOL FASTCALL display_vsync(void);/* VSYNCCxg */
static BOOL FASTCALL display_blank(void);/* VBLANK,HBLANKCxg */
static void FASTCALL display_setup(void);/* CxgZbgAbv */
static void FASTCALL vram_scroll(WORD offset);/* VRAMXN[ */
#if XM7_VER == 1 && defined(L4CARD)
static BOOL FASTCALL display_text_blink(void);/* eLXguNCxg */
static BOOL FASTCALL display_cursor_blink(void);/* J[\uNCxg */
#endif

#if (XM7_VER >= 3) && (defined(_OMF) || defined(_WIN32))
extern void memcpy400l(BYTE *, BYTE *, int);
										/* 400CXN[p] */
#endif

/*
 *	24/32bit Colorp26F[hPxe[u
 */
#if XM7_VER >= 3
const BYTE truecolorbrightness[64] = {
	  0,	  4,	  8,	 12,	 16,	 20,	 24,	 28,
	 32,	 36,	 40,	 45,	 49,	 53,	 57,	 61,
	 65,	 69,	 73,	 77,	 81,	 85,	 89,	 93,
	 97,	101,	105,	109,	113,	117,	121,	125,
	130,	134,	138,	142,	146,	150,	154,	158,
	162,	166,	170,	174,	178,	182,	186,	190,
	194,	198,	202,	206,	210,	215,	219,	223,
	227,	231,	235,	239,	243,	247,	251,	255,
};
#endif


/*
 *	fBXvC
 *	
 */
BOOL FASTCALL display_init(void)
{
	/* VRAMXN[pobt@m */
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
	vram_buf = (BYTE *)malloc(0x8000);
#else
	vram_buf = (BYTE *)malloc(0x4000);
#endif
	if (vram_buf == NULL) {
		return FALSE;
	}

#if XM7_VER == 1 && defined(L4CARD)
	/* 200C[hɐݒ */
	enable_400line = FALSE;
#endif

	/* `ʒm^C~OVSYNC */
	draw_aftervsync = TRUE;

	/* MAGUSpb`͗L */
	magus_patch = TRUE;

	/* CRTCItZbg[NNA */
	memset(crtc_offset, 0, sizeof(crtc_offset));

	return TRUE;
}

/*
 *	fBXvC
 *	N[Abv
 */
void FASTCALL display_cleanup(void)
{
/*
	ASSERT(vram_buf);
*/

	if (vram_buf) {
		free(vram_buf);
	}
}

/*
 *	fBXvC
 *	Zbg
 */
void FASTCALL display_reset(void)
{
#if XM7_VER >= 2
	int i;
#endif

	/* Zbg̃XN[ʒu␳ */
#if XM7_VER >= 2
	for (i=0; i<2; i++) {
		vram_scroll((WORD)-crtc_offset[i]);
	}
#else
	vram_scroll((WORD)-crtc_offset[0]);
#endif

	/* CRTWX^ */
	crt_flag = FALSE;
	vrama_flag = FALSE;
	memset(vram_offset, 0, sizeof(vram_offset));
	memset(crtc_offset, 0, sizeof(crtc_offset));
	vram_offset_flag = FALSE;
	memset(vram_offset_count, 0, sizeof(vram_offset_count));
	now_raster = 0;

	/* 荞݁ACxg */
	blank_flag = TRUE;
#if XM7_VER >= 2
	subnmi_flag = TRUE;
	vsync_flag = FALSE;

	/* ANeBuy[WA\y[W */
	vram_active = 0;
	vram_aptr = vram_c;
	vram_display = 0;
	vram_dptr = vram_c;
#if XM7_VER >= 3
	subram_vrambank = 0;

	/* n[hEFAEBhE */
	window_x1 = window_x2 = 0;
	window_y1 = window_y2 = 0;
	window_dx1 = window_dx2 = 0;
	window_dy1 = window_dy2 = 0;
	window_open = FALSE;

	/* ANeBuubNA\ubN */
	block_active = 0;
	block_display = 0;
	vram_ablk = vram_c;
	vram_dblk = vram_c;
	vram_bdptr = vram_c + 0x18000;
	vram_bdblk = vram_bdptr;

	/* TuROM */
	sub_kanji_addr = 0;
	sub_kanji_bank = FALSE;
#endif	/* XM7_VER >= 3 */
#endif	/* XM7_VER >= 2 */

#if XM7_VER == 1
	/* 荞݁ACxg */
	vsync_flag = FALSE;
	blank_flag = TRUE;

#ifdef L4CARD
	/* TextVRAM */
	text_cursor_count = 0;
	text_scroll_count = 0;
	text_start_addr = 0x0000;
	text_blink = TRUE;
	cursor_addr = 0x0000;
	cursor_blink = TRUE;
	text_blink_count = 0;
	cursor_blink_count = 0;
	workram_select = FALSE;

	/* CRTC */
	crtc_regnum = 0;
	memset(crtc_register, 0, sizeof(crtc_register));

	/* TuROM */
	sub_kanji_addr = 0;

	/* 400C[h̓eLXguNCxgǉ */
	if (enable_400line && enable_400linecard) {
		schedule_setevent(EVENT_TEXT_BLINK, 160*1000, display_text_blink);
	}
	else {
		schedule_delevent(EVENT_TEXT_BLINK);
	}
#endif
#endif

	/* 20msƂɋNCxgǉ */
	schedule_setevent(EVENT_SUBTIMER, 20000, subcpu_event);

	/* VSYNC, VBLANK, HBLANK̃ZbgAbv */
	display_setup();
}

#if XM7_VER == 1 && defined(L4CARD)
/*
 *	eLXguNCxg
 */
static BOOL FASTCALL display_text_blink(void)
{
	WORD addr;
	WORD ofsaddr;

	/* 400C[hłȂ΃Cxg폜ċA */
	if (!(enable_400line && enable_400linecard)) {
		schedule_delevent(EVENT_TEXT_BLINK);
		return TRUE;
	}

	/* eLXguN (320ms) */
	if (text_blink_count ++ >= 2) {
		/* uNԂ𔽓] */
		text_blink = (!text_blink);

		/* uNLN^ */
		for (addr = 0; addr < 4000; addr += (WORD)2) {
			ofsaddr = (WORD)((addr + text_start_addr) & 0xFFE);
			if (tvram_c[ofsaddr + 1] & 0x10) {
				tvram_notify(ofsaddr, 0);
			}
		}

		/* JE^Zbg */
		text_blink_count = 0;
	}

	/* J[\uN (320/160ms) */
	if (crtc_register[10] & 0x40) {
		cursor_blink_count++;
		if ((cursor_blink_count >= 2) || !(crtc_register[10] & 0x20)) {
			/* uNԂ𔽓] */
			cursor_blink = (!cursor_blink);

			/* J[\ʒuĕ\ */
			tvram_notify(cursor_addr, 0);

			/* JE^Zbg */
			cursor_blink_count = 0;
		}
	}

	return TRUE;
}
#endif

/*
 *	VSYNCCxg
 */
static BOOL FASTCALL display_vsync(void)
{
	if (!vsync_flag) {
		if ((blank_count & 0xfff) > 0) {
			/* ꏄ */
			display_setup();
			return TRUE;
		}

		/* ꂩ琂 */
		vsync_flag = TRUE;
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
		if (blank_count & 0x1000) {
			/* 400C(24kHz[h) 0.33ms */
			schedule_setevent(EVENT_VSYNC, 330, display_vsync);
		}
		else {
			/* 200C(15kHz[h) 0.51ms */
			schedule_setevent(EVENT_VSYNC, 510, display_vsync);
		}
#else
		/* 200C(15kHz[h) 0.51ms */
		schedule_setevent(EVENT_VSYNC, 510, display_vsync);
#endif

		/* rfIfBW^CY */
#if XM7_VER >= 2
		if (digitize_enable) {
			if (digitize_keywait || simpose_mode == 0x03) {
				digitize_notify();
			}
		}
#else
		blank_count ++;
#endif
	}
	else {
		/* ꂩ琂\ */
		now_raster = 0;
		vblankperiod_notify();
		vsync_flag = FALSE;
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
		if (blank_count & 0x1000) {
			/* 400C(24kHz[h) 0.98ms + 16.4ms */
			schedule_setevent(EVENT_VSYNC, 980 + 16400, display_vsync);
		}
		else {
			/* 200C(15kHz[h) 1.91ms + 12.7ms */
			schedule_setevent(EVENT_VSYNC, 1910 + 12700, display_vsync);
		}
#else
		/* 200C(15kHz[h) 1.91ms + 12.7ms */
		schedule_setevent(EVENT_VSYNC, 1910 + 12700, display_vsync);
#endif

		/* VSYNCʒm */
		if (draw_aftervsync) {
			vsync_notify();
		}
	}

	return TRUE;
}

/*
 *	VBLANK,HBLANKCxg
 */
static BOOL FASTCALL display_blank(void)
{
	if ((blank_count & 0xfff) == 0) {
		if (blank_flag) {
			/* ꂩ珉 */
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
			if (blank_count & 0x1000) {
				/* 400CB11us */
				schedule_setevent(EVENT_BLANK, 11, display_blank);
			}
			else {
				/* 200CB24us */
				schedule_setevent(EVENT_BLANK, 24, display_blank);
			}
#else
			/* 200CB24us */
			schedule_setevent(EVENT_BLANK, 24, display_blank);
#endif
			blank_count++;
			return TRUE;
		}
	}

	if (blank_flag) {
		/* ꂩ琅\ */
		blank_flag = FALSE;
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
		if (blank_count & 0x1000) {
			/* 400CB30us */
			schedule_setevent(EVENT_BLANK, 30, display_blank);
		}
		else {
			/* 200CB39us܂40us */
			schedule_setevent(EVENT_BLANK, 39 + (blank_count & 1), display_blank);
		}
#else
		/* 200CB39us܂40us */
		schedule_setevent(EVENT_BLANK, 39 + (blank_count & 1), display_blank);
#endif
		blank_count++;
		return TRUE;
	}
	else {
		/* ꂩ琅 */
		hblank_notify();
		now_raster ++;
		blank_flag = TRUE;
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
		if (blank_count & 0x1000) {
			/* 400CB11us */
			schedule_setevent(EVENT_BLANK, 11, display_blank);
		}
		else {
			/* 200CB24us */
			schedule_setevent(EVENT_BLANK, 24, display_blank);
		}
#else
		/* 200CB24us */
		schedule_setevent(EVENT_BLANK, 24, display_blank);
#endif

		return TRUE;
	}
}

/*
 *	CxgZbgAbv
 */
static void FASTCALL display_setup(void)
{
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
	/* 200C,400C̔ */
#if XM7_VER >= 3
	if (screen_mode == SCR_400LINE) {
#else
	if (enable_400line && enable_400linecard) {
#endif
		blank_count = 0x1000;
		schedule_setevent(EVENT_VSYNC, 340, display_vsync);
		schedule_setevent(EVENT_BLANK, 1650, display_blank);
	}
	else {
		blank_count = 0;
		schedule_setevent(EVENT_VSYNC, 1520, display_vsync);
		schedule_setevent(EVENT_BLANK, 3940, display_blank);
	}
#else
	blank_count = 0;
	schedule_setevent(EVENT_VSYNC, 1520, display_vsync);
	schedule_setevent(EVENT_BLANK, 3940, display_blank);

	/* uLO */
	vsync_flag = FALSE;
	blank_flag = TRUE;
#endif

	/* VSYNCʒm */
	if (!draw_aftervsync) {
		vsync_notify();
	}
}

/*
 *	TuCPU
 *	Cxg
 */
static BOOL FASTCALL subcpu_event(void)
{
#if XM7_VER >= 2
	/* Ô߁A`FbN */
	if (!subnmi_flag && (fm7_ver >= 2)) {
		return FALSE;
	}
#endif

	/* NMI荞݂N */
	subcpu_nmi();
	return TRUE;
}

/*
 *	|C^Đݒ
 */
void FASTCALL display_setpointer(BOOL redraw)
{
#if XM7_VER >= 3
	/* ʃ[hԍ */
	if (mode400l) {
		screen_mode = SCR_400LINE;
	}
	else if (mode256k) {
		screen_mode = SCR_262144;
	}
	else if (mode320) {
		screen_mode = SCR_4096;
	}
	else {
		screen_mode = SCR_200LINE;
	}
#endif

#if XM7_VER >= 2
	/* ANeBu|C^EANeBuubN|C^ */
	vram_aptr = vram_c;
#if XM7_VER >= 3
	vram_ablk = vram_c;
	switch (screen_mode) {
		case SCR_400LINE	:	/* 640x400 8F */
								vram_aptr += (subram_vrambank * 0x8000);
								if (block_active) {
									vram_aptr += 0x18000;
									vram_ablk += 0x18000;
								}
								break;
		case SCR_262144		:	/* 320x200 262144F */
								switch (subram_vrambank) {
									case	0	: break;
									case	1	: vram_aptr += 0x4000;
												  break;
									case	2	: vram_aptr += 0x18000;
												  break;
								}
								break;
		default				:	/* 640x200A320x200 4096F */
								if (vram_active) {
									vram_aptr += 0x4000;
								}
								if (block_active) {
									vram_aptr += 0x18000;
								}
	}
#else
	if (vram_active) {
		vram_aptr += 0xc000;
	}
#endif

	/* \|C^A\ubN|C^ */
	vram_dptr = vram_c;
#if XM7_VER >= 3
	vram_dblk = vram_c;
	vram_bdblk = vram_c;
	if ((screen_mode == SCR_200LINE) && vram_display) {
		vram_dptr += 0x4000;
	}
	vram_bdptr = vram_dptr;
	if (block_display) {
		vram_dptr += 0x18000;
		vram_dblk += 0x18000;
	}
	else {
		vram_bdptr += 0x18000;
		vram_bdblk += 0x18000;
	}
#else
	if (!mode320 && vram_display) {
		vram_dptr += 0xc000;
	}
#endif	/* XM7_VER >= 3 */
#endif	/* XM7_VER >= 2 */

	/* KvȂĕ` */
	if (redraw) {
		display_notify();
	}
}

/*
 *	n[hEFAEChE
 *	I[v`FbNE͈͌
 */
#if XM7_VER >= 3
static void FASTCALL check_window_open(void)
{
	/* Xs<Xe and Ys<Ye ł΁AEBhEI[v */
	if ((window_x1 < window_x2) && (window_y1 < window_y2)) {
		window_open = TRUE;
	}
	else {
		window_open = FALSE;
		window_dx1 = 0;
		window_dx2 = 0;
		window_dy1 = 0;
		window_dy2 = 0;
	}

	/* ĕ`w */
	window_notify();
}

/*
 *	n[hEFAEChE
 *	NbsO
 */
void FASTCALL window_clip(int mode)
{
	static const WORD max_x[4] = { 640, 320, 640, 320 };
	static const WORD max_y[4] = { 200, 200, 400, 200 };

	ASSERT((mode >= 0) && (mode <= 2));

	/* XNbsO */
	window_dx1 = window_x1;
	window_dx2 = window_x2;
	if (window_dx1 > max_x[mode]) {
		window_dx1 = max_x[mode];
	}
	if (window_dx2 > max_x[mode]) {
		window_dx2 = max_x[mode];
	}

	/* YNbsO */
	window_dy1 = window_y1;
	window_dy2 = window_y2;
	if (window_dy1 > max_y[mode]) {
		window_dy1 = max_y[mode];
	}
	if (window_dy2 > max_y[mode]) {
		window_dy2 = max_y[mode];
	}
}
#endif

/*
 *	4096F/262144F[hp VRAMXN[
 */
#if XM7_VER >= 2
static void FASTCALL vram_scroll_analog(WORD offset, DWORD addr)
{
	int i;
	BYTE *vram;

#if XM7_VER >= 3
	for (i=0; i<3; i++) {
		vram = (BYTE *)((vram_c + addr) + 0x8000 * i);

		/* e|obt@փRs[ */
		memcpy(vram_buf, vram, offset);
		memcpy(&vram_buf[0x2000], &vram[0x2000], offset);

		/* O֋l߂ */
		memcpy(vram, (vram + offset), 0x4000 - offset);

		/* e|obt@蕜 */
		memcpy(vram + (0x2000 - offset), vram_buf, offset);
		memcpy(vram + (0x4000 - offset), &vram_buf[0x2000], offset);
	}
#else
	for (i=0; i<6; i++) {
		vram = (BYTE *)((vram_c + addr) + 0x2000 * i);

		/* e|obt@փRs[ */
		memcpy(vram_buf, vram, offset);

		/* O֋l߂ */
		memcpy(vram, (vram + offset), 0x2000 - offset);

		/* e|obt@蕜 */
		memcpy(vram + (0x2000 - offset), vram_buf, offset);
	}
#endif
}
#endif

/*
 *	400C[hVRAMXN[p] (C)
 */
#if (XM7_VER >= 3) && (!(defined(_OMF) || defined(_WIN32)))
static void FASTCALL memcpy400l(BYTE *dest, BYTE *src, WORD siz)
{
	siz >>= 1;
	while (siz) {
		*dest = *src;
		src += 2;
		dest += 2;
		siz --;
	}
}
#endif

/*
 *	VRAMXN[
 */
static void FASTCALL vram_scroll(WORD offset)
{
	int i;
	BYTE *vram;

	if (offset == 0) {
		return;
	}

#if XM7_VER >= 2
#if XM7_VER >= 3
	/* 400C */
	if (screen_mode == SCR_400LINE) {
		/* 400C ItZbg}XN */
		offset &= 0x3fff;
		offset <<= 1;

		/* [v */
		for (i=0; i<3; i++) {
			vram = (BYTE *)(vram_c + 0x8000 * i + vram_active);

			/* e|obt@փRs[ */
			memcpy400l(vram_buf, vram, offset);

			/* O֋l߂ */
			memcpy400l(vram, (vram + offset), 0x8000 - offset);

			/* e|obt@蕜 */
			memcpy400l(vram + (0x8000 - offset), vram_buf, offset);
		}
		return;
	}

	/* 4096F/262144F */
	if (screen_mode & SCR_ANALOG) {
#else
	/* 4096F */
	if (mode320) {
#endif
		/* 320 ItZbg}XN */
		offset &= 0x1fff;

		if (vram_active == 1) {
			/* oN1 */
#if XM7_VER >= 3
			vram_scroll_analog(offset, 0x04000);
#else
			vram_scroll_analog(offset, 0x0c000);
#endif
		}
		else {
			/* oN0 */
			vram_scroll_analog(offset, 0x00000);
#if XM7_VER >= 3
			if (screen_mode == SCR_262144) {
				/* 26F[h̓oN2ɃXN[ */
				vram_scroll_analog(offset, 0x18000);
			}
#endif
		}

		return;
	}
#endif	/* XM7_VER >= 2 */

#if XM7_VER == 1 && defined(L4CARD)
	if (enable_400line && enable_400linecard) {
		/* 400CPF̓_ŃXN[s */
		/* (C$FD37̋Č̊֌W) */
		return;
	}
#endif

	/* 8F */
	offset &= 0x3fff;

	/* [v */
	for (i=0; i<3; i++) {
#if XM7_VER >= 3
		vram = (BYTE *)(vram_c + 0x8000 * i);
		if (vram_active) {
			vram += 0x4000;
		}
#elif XM7_VER >= 2
		vram = (BYTE *)(vram_c + 0x4000 * i);
		if (vram_active) {
			vram += 0xc000;
		}
#else
		vram = (BYTE *)(vram_c + 0x4000 * i);
#endif

		/* e|obt@փRs[ */
		memcpy(vram_buf, vram, offset);

		/* O֋l߂ */
		memcpy(vram, (vram + offset), 0x4000 - offset);

		/* e|obt@蕜 */
		memcpy(vram + (0x4000 - offset), vram_buf, offset);
	}
}

/*
 *	400C[hpVRAMzu␳
 */
#if XM7_VER >= 3
BOOL FASTCALL fix_vram_address(void)
{
	DWORD	i;

	for (i=0; i<0x30000; i+=0x18000) {
		memcpy(&vram_buf[0x00000], &vram_c[0x04000 + i], 0x4000);
		memcpy(&vram_buf[0x04000], &vram_c[0x10000 + i], 0x4000);
		memcpy(&vram_c[0x04000 + i], &vram_c[0x08000 + i], 0x4000);
		memcpy(&vram_c[0x10000 + i], &vram_c[0x0c000 + i], 0x4000);
		memcpy(&vram_c[0x08000 + i], &vram_buf[0x04000], 0x4000);
		memcpy(&vram_c[0x0c000 + i], &vram_buf[0x00000], 0x4000);
	}

	return TRUE;
}
#endif

#if XM7_VER == 1 && defined(L4CARD)
/*
 *	J[\ ʒuEuNxĐݒ
 */
void FASTCALL cursor_setup(void)
{
	WORD cursor_addr_old;

	/* J[\ړ */
	cursor_addr_old = cursor_addr;
	cursor_addr  = (WORD)(crtc_register[14] << 10);
	cursor_addr |= (WORD)(crtc_register[15] << 2);
	if (cursor_lsb) {
		cursor_addr += (WORD)2;
	}
	cursor_addr &= (WORD)0xFFF;

	/* J[\WƐVJ[\Wꂼĕ` */
	tvram_notify(cursor_addr_old, 0);
	tvram_notify(cursor_addr, 0);
}

/*
 *	CRTC(HD6845) PoCgǂݍ
 */
static BYTE FASTCALL crtc_readb(BYTE reg)
{
	if ((reg >= 0x0c) && (reg <= 0x11)) {
		/* 0x0c`0x11͋LĂlԂ */
		return crtc_register[reg];
	}
	else {
		/* 0x0c`0x11ȊO̓CgI[ */
		return 0xff;
	}
}

/*
 *	CRTC(HD6845) PoCg
 */
static void FASTCALL crtc_writeb(BYTE reg, BYTE dat)
{
	/* 񂾒lۑ */
	crtc_register[reg] = dat;

	switch (reg) {
		/* J[\TCY */
		case 0x0a :
		case 0x0b :
			cursor_setup();
			break;

		/* eLXgX^[gAhX() */
		case 0x0c :
			text_start_addr &= 0x03FC;
			text_start_addr |= (WORD)((dat & 0x03) << 10);
			text_scroll_count ++;
			if ((text_scroll_count & 1) == 0) {
				tvram_redraw_notify();
			}
			break;

		/* eLXgX^[gAhX() */
		case 0x0d :
			text_start_addr &= 0xFC00;
			text_start_addr |= (WORD)(dat << 2);
			text_scroll_count ++;
			if ((text_scroll_count & 1) == 0) {
				tvram_redraw_notify();
			}
			break;

		/* J[\AhX */
		case 0x0e :
		case 0x0f :
			text_cursor_count ++;
			if ((text_cursor_count & 1) == 0) {
				cursor_setup();
			}
			break;
	}
}
#endif

/*
 *	fBXvC
 *	PoCgǂݍ
 *	C|TuC^tF[XM܂
 */
BOOL FASTCALL display_readb(WORD addr, BYTE *dat)
{
	BYTE ret;
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
	int offset;
#endif	/* XM7_VER >= 3 */

	switch (addr) {
		/* LZIRQ ACK */
		case 0xd402: 
			subcancel_flag = FALSE;
			subcancel_request = FALSE;
			subcpu_irq();
			*dat = 0xff;
			return TRUE;

		/* BEEP */
		case 0xd403:
			beep_flag = TRUE;
			schedule_setevent(EVENT_BEEP, 205000, mainetc_beep);
			*dat = 0xff;

			/* ʒm */
			beep_notify();
			return TRUE;

		/* AeVIRQ ON */
		case 0xd404:
			subattn_flag = TRUE;
			*dat = 0xff;
			maincpu_firq();
			return TRUE;

#if XM7_VER == 1
		/* Tu[hWX^ */
		case 0xd405:
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			ret = 0xff;

#ifdef L4CARD
			/* bit7`1400CJ[ĥݗL */
			if (enable_400linecard) {
				/* uLO */
				if (blank_flag) {
					ret &= (BYTE)~0x80;
				}

				/* VSYNC */
				if (!vsync_flag) {
					ret &= (BYTE)~0x40;
				}

				/* C */
				if (select_400line) {
					ret &= ~0x20;
				}

				/* CURSOR LSB */
				if (!cursor_lsb) {
					ret &= (BYTE)~0x10;
				}

				/* WIDTH */
				if (width40_flag) {
					ret &= (BYTE)~0x08;
				}

				/* [NRAMI */
				if (!workram_select) {
					ret &= (BYTE)~0x04;
				}

				/* 400C[h */
				if (enable_400line) {
					ret &= ~0x02;
				}
			}
#endif

			/* TCNX`[ */
			if (cycle_steal) {
				ret &= ~0x01;
			}

			*dat = ret;
			return TRUE;
#endif

#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
		/* TuROM */
		case 0xd406:		/* TuLEFT */
		case 0xd407:		/* TuRIGHT */
#if XM7_VER >= 3
			if ((fm7_ver >= 3) && subkanji_flag) {
				/* AhX̓[hPʂŁA8bit̂ݎ擾 */
				offset = sub_kanji_addr << 1;
				if (sub_kanji_bank) {
					*dat = kanji_rom2[offset + (addr & 1)];
				}
				else {
					*dat = kanji_rom[offset + (addr & 1)];
				}
			}
#else
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			if (subkanji_flag) {
				/* AhX̓[hPʂŁA8bit̂ݎ擾 */
				offset = sub_kanji_addr << 1;
				if ((offset >= 0x6000) && (offset < 0x8000) &&
					 !kanji_asis_flag) {
					/* FM-7[h$6000`$7FFF͖`̈ */
					*dat = (BYTE)(addr & 1);
				}
				else {
					/* ʏ̈ */
					*dat = kanji_rom[offset + (addr & 1)];
				}
			}
#endif
			else {
				*dat = 0xff;
			}
			return TRUE;
#endif

		/* CRT ON */
		case 0xd408:
			if (!crt_flag) {
				crt_flag = TRUE;
				/* CRT OFFON */
				display_notify();
			}
			*dat = 0xff;
			return TRUE;

		/* VRAMANZX ON */
		case 0xd409:
			vrama_flag = TRUE;
			*dat = 0xff;
			return TRUE;

		/* BUSYtO OFF */
		case 0xd40a:
			subbusy_flag = FALSE;
			*dat = 0xff;
			return TRUE;

#if XM7_VER == 1 && defined(L4CARD)
		/* CRTCAhXWX^(400LINE CARD) */
		case 0xd40b:
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				*dat = (BYTE)(crtc_regnum & 0x1f);
			}
			else {
				*dat = 0xff;
			}
			return TRUE;

		/* CRTCf[^WX^(400LINE CARD) */
		case 0xd40c:
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				*dat = (BYTE)crtc_readb(crtc_regnum);
			}
			else {
				*dat = 0xff;
			}
			return TRUE;
#endif

#if XM7_VER >= 3
		/* FM77AV40 TuRAMoNZNg/TuROMZNg */
		case 0xd42e:
			/* fm7_verɊւ炸AǂݏooȂ */
			*dat = 0xff;
			return TRUE;

		/* FM77AV40 400C/26FpVRAMoNZNg */
		case 0xd42f:
			if (fm7_ver >= 3) {
				*dat = (BYTE)(0xfc | (subram_vrambank & 3));
			}
			else {
				*dat = 0xff;
			}
			return TRUE;
#endif

#if XM7_VER >= 2
		/* FM77AV MISCWX^ */
		case 0xd430:
			if (fm7_ver >= 2) {
				ret = 0xff;

				/* uLO */
				if (blank_flag) {
					ret &= (BYTE)~0x80;
				}

				/*  */
				if (line_busy) {
					ret &= (BYTE)~0x10;
					/* LINE BOOST͈񂾂BUSY */
					if (line_boost) {
						line_busy = FALSE;
						schedule_delevent(EVENT_LINE);
					}
				}

				/* VSYNC */
				if (!vsync_flag) {
					ret &= (BYTE)~0x04;
				}

				/* TuRESETXe[^X */
				if (!subreset_flag) {
					ret &= (BYTE)~0x01;
				}

				*dat = ret;
				return TRUE;
			}

			return FALSE;
#endif
	}

	return FALSE;
}

/*
 *	fBXvC
 *	PoCg
 *	C|TuC^tF[XM܂
 */
BOOL FASTCALL display_writeb(WORD addr, BYTE dat)
{
	WORD offset;
#if XM7_VER >= 2
	BOOL redraw_flag;
#endif

	switch (addr) {
#if XM7_VER == 1
		/* Tu[hWX^ */
		case 0xd405:
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			/* TCNX`[ */
			if (dat & 0x01) {
				cycle_steal = FALSE;
			}
			else {
				cycle_steal = TRUE;
			}

#ifdef L4CARD
			/* bit4`1400CJ[hL̂ݗL */
			if (enable_400linecard) {
				/* CURSOR LSB */
				if (dat & 0x10) {
					cursor_lsb = TRUE;
				}
				else {
					cursor_lsb = FALSE;
				}

				/* WIDTH */
				if (dat & 0x08) {
					width40_flag = FALSE;
				}
				else {
					width40_flag = TRUE;
				}

				/* [NRAMI */
				if (dat & 0x04) {
					workram_select = TRUE;
				}
				else {
					workram_select = FALSE;
				}

				/* 400CJ[h [h؂芷 */
				if (dat & 0x02) {
					if (!enable_400line) {
						return TRUE;
					}
					enable_400line = FALSE;
				}
				else {
					if (enable_400line) {
						return TRUE;
					}
					enable_400line = TRUE;
				}

				/* tOރZbg */
				subreset_flag = TRUE;
				subbusy_flag = TRUE;

				/* CRTWX^Zbg */
				display_reset();
				display_notify();

				/* INS LED */
				ins_flag = FALSE;

				/* TuCPUZbg */
				subcpu_reset();
			}
#endif

			return TRUE;
#endif

#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
		/* TuROM AhX */
		case 0xd406:
#if XM7_VER >= 3
			if (fm7_ver >= 3) {
				sub_kanji_addr &= (WORD)0x00ff;
				sub_kanji_addr |= (WORD)(dat << 8);
			}
#else
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			sub_kanji_addr &= (WORD)0x00ff;
			sub_kanji_addr |= (WORD)(dat << 8);
#endif
			return TRUE;

		/* TuROM AhX */
		case 0xd407:
#if XM7_VER >= 3
			if (fm7_ver >= 3) {
				sub_kanji_addr &= (WORD)0xff00;
				sub_kanji_addr |= (WORD)dat;
			}
#else
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			sub_kanji_addr &= (WORD)0xff00;
			sub_kanji_addr |= (WORD)dat;
#endif
			return TRUE;
#endif

		/* CRT OFF */
		case 0xd408:
			if (crt_flag) {
				/* CRT ONOFF */
				crt_flag = FALSE;
				display_notify();
			}
			crt_flag = FALSE;
			return TRUE;

		/* VRAMANZX OFF */
		case 0xd409:
			vrama_flag = FALSE;
			return TRUE;

		/* BUSYtO ON */
		case 0xd40a:
			if (magus_patch) {
				/* CLR߃`FbN */
				if ((fetch_op == 0x0f) ||
					(fetch_op == 0x6f) ||
					(fetch_op == 0x7f)) {
					busy_CLR_count ++;
					if (busy_CLR_count >= 2) {
						subbusy_flag = FALSE;
					}
					else {
						subbusy_flag = TRUE;
					}
				}
				else {
					busy_CLR_count = 0;
					subbusy_flag = TRUE;
				}
			}
			else {
				busy_CLR_count = 0;
				subbusy_flag = TRUE;
			}
			return TRUE;

#if XM7_VER == 1 && defined(L4CARD)
		/* CRTCAhXWX^(400LINE CARD) */
		case 0xd40b:
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				crtc_regnum = (BYTE)(dat & 0x1f);
			}
			return TRUE;

		/* CRTCf[^WX^(400LINE CARD) */
		case 0xd40c:
			/* FM-77[ĥݗL */
			if (fm_subtype != FMSUB_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				crtc_writeb(crtc_regnum, dat);
			}
			return TRUE;
#endif

		/* VRAMItZbgAhX */
		case 0xd40e:
		case 0xd40f:
			if (addr == 0xd40e) {
				/* VRAMItZbgAhX  */
#if XM7_VER == 1 && defined(L4CARD)
				/* ʃ[hɂėLrbgω */
				if (enable_400line && enable_400linecard) {
					offset = (WORD)(dat & 0x7f);
				}
				else {
					offset = (WORD)(dat & 0x3f);
				}
#else
				offset = (WORD)(dat & 0x3f);
#endif
				offset <<= 8;
#if XM7_VER >= 2
				offset |= (WORD)(vram_offset[vram_active] & 0xff);
#else
				offset |= (WORD)(vram_offset[0] & 0xff);
#endif
			}
			else {
				/* VRAMItZbgAhX  */
#if XM7_VER >= 2
				/* gItZbgtOOFFȂA5bit͖ */
				if (!vram_offset_flag) {
					dat &= 0xe0;
				}
				offset = (WORD)(vram_offset[vram_active] & 0x3f00);
				offset |= (WORD)dat;
#else
#if XM7_VER == 1 && defined(L4CARD)
				/* ʃ[hɂėLrbgω */
				if (enable_400line && enable_400linecard) {
					offset = (WORD)(vram_offset[0] & 0x7f00);
					offset |= (WORD)(dat & 0xfe);
				}
				else {
					offset = (WORD)(vram_offset[0] & 0x3f00);
					offset |= (WORD)(dat & 0xe0);
				}
#else
				offset = (WORD)(vram_offset[0] & 0x3f00);
				offset |= (WORD)(dat & 0xe0);
#endif
#endif
			}

#if XM7_VER >= 2
			vram_offset[vram_active] = offset;
			/* JEgAbvAXN[ */
			vram_offset_count[vram_active]++;
			if ((vram_offset_count[vram_active] & 1) == 0) {
				vram_scroll((WORD)(vram_offset[vram_active] -
									crtc_offset[vram_active]));
				crtc_offset[vram_active] = vram_offset[vram_active];
				display_notify();
			}
#else
			vram_offset[0] = offset;
			/* JEgAbvAXN[ */
			vram_offset_count[0]++;
			if ((vram_offset_count[0] & 1) == 0) {
				vram_scroll((WORD)(vram_offset[0] - crtc_offset[0]));
				crtc_offset[0] = vram_offset[0];
				display_notify();
			}
#endif
			return TRUE;

#if XM7_VER >= 3
		/* FM77AV40 TuRAMoNZNg/TuROMZNg */
		case 0xd42e:
			if (fm7_ver >= 3) {
				/* bit0-2:CGRAMoNZNg */
				cgram_bank = (BYTE)(dat & 0x07);

				/* bit3,4:R\[RAMoNZNg */
				consram_bank = (BYTE)((dat >> 3) & 0x03);
				if (consram_bank == 3) {
					/* oN3݂͑Ȃ */
					ASSERT(FALSE);
					consram_bank = 0;
				}

				/* bit7:1E2ZNg */
				if (dat & 0x80) {
					/* 2 */
					sub_kanji_bank = TRUE;
				}
				else {
					/* 1 */
					sub_kanji_bank = FALSE;
				}
			}
			return TRUE;

		/* FM77AV40 400C/26FpVRAMoNZNg */
		case 0xd42f:
			if (fm7_ver >= 3) {
				subram_vrambank = (BYTE)(dat & 0x03);
				if (subram_vrambank == 3) {
					/* oN3݂͑Ȃ */
					ASSERT(FALSE);
					subram_vrambank = 0;
				}

				/* |C^č\ */
				display_setpointer(FALSE);
			}
			return TRUE;
#endif

#if XM7_VER >= 2
		/* FM77AV MISCWX^ */
		case 0xd430:
			if (fm7_ver >= 2) {
				redraw_flag = FALSE;

				/* NMI}XN */
				if (dat & 0x80) {
					subnmi_flag = FALSE;
					event[EVENT_SUBTIMER].flag = EVENT_DISABLED;
					subcpu.intr &= ~INTR_NMI;
				}
				else {
					subnmi_flag = TRUE;
					event[EVENT_SUBTIMER].flag = EVENT_ENABLED;
				}

				/* ANeBuy[W */
				if (dat & 0x20) {
					vram_active = 1;
				}
				else {
					vram_active = 0;
				}

				/* fBXvCy[W */
				if (dat & 0x40) {
					if (vram_display == 0) {
						vram_display = 1;

						/* 200C8F[hł͉ʍĕ`悪Kv */
#if XM7_VER >= 3
						if (screen_mode == SCR_200LINE) {
#else
						if (!mode320) {
#endif
							redraw_flag = TRUE;
						}
					}
				}
				else {
					if (vram_display == 1) {
						vram_display = 0;

						/* 200C8F[hł͉ʍĕ`悪Kv */
#if XM7_VER >= 3
						if (screen_mode == SCR_200LINE) {
#else
						if (!mode320) {
#endif
							redraw_flag = TRUE;
						}
					}
				}

				/* gVRAMItZbgWX^ */
				if (dat & 0x04) {
					vram_offset_flag = TRUE;
				}
				else {
					vram_offset_flag = FALSE;
				}

				/* CGROMoN */
				cgrom_bank = (BYTE)(dat & 0x03);

				/* |C^č\Eʍĕ` */
				display_setpointer(redraw_flag);
			}

			return TRUE;
#endif

#if XM7_VER >= 3
		/* FM77AV40EX VRAMubNZNg */
		case 0xd433:
			if (fm7_ver >= 3) {
				redraw_flag = FALSE;

				/* bit0:ANeBuubNZNg */
				if (dat & 0x01) {
					block_active = 1;
				}
				else {
					block_active = 0;
				}

				/* bit4:\ubNZNg */
				if (dat & 0x10) {
					if (block_display == 0) {
						block_display = 1;
						if (screen_mode != SCR_262144) {
							redraw_flag = TRUE;
						}
					}
				}
				else {
					if (block_display == 1) {
						block_display = 0;
						if (screen_mode != SCR_262144) {
							redraw_flag = TRUE;
						}
					}
				}

				/* |C^č\Eʍĕ` */
				display_setpointer(redraw_flag);
			}
			return TRUE;

		/* FM77AV40EX n[hEFAEBhE */
		case 0xd438:			/* XEBhEX^[gAhX() */
		case 0xd439:			/* XEBhEX^[gAhX() */
		case 0xd43a:			/* XEBhEGhAhX() */
		case 0xd43b:			/* XEBhEGhAhX() */
		case 0xd43c:			/* YEBhEX^[gAhX() */
		case 0xd43d:			/* YEBhEX^[gAhX() */
		case 0xd43e:			/* YEBhEGhAhX() */
		case 0xd43f:			/* YEBhEGhAhX() */
			if (fm7_ver <= 2) {
				return TRUE;
			}

			switch (addr & 7) {
				case 0:	/* XEBhEX^[gAhX() */
						window_x1 &= (WORD)0x00f8;
						window_x1 |= (WORD)((dat & 0x03) << 8);
						break;
				case 1:	/* XEBhEX^[gAhX() */
						window_x1 &= (WORD)0x0300;
						window_x1 |= (WORD)(dat & 0xf8);
						break;
				case 2:	/* XEBhEGhAhX() */
						window_x2 &= (WORD)0x00f8;
						window_x2 |= (WORD)((dat & 0x03) << 8);
						break;
				case 3:	/* XEBhEGhAhX() */
						window_x2 &= (WORD)0x0300;
						window_x2 |= (WORD)(dat & 0xf8);
						break;
				case 4:	/* YEBhEX^[gAhX() */
						window_y1 &= (WORD)0x00ff;
						window_y1 |= (WORD)((dat & 0x01) << 8);
						break;
				case 5:	/* YEBhEX^[gAhX() */
						window_y1 &= (WORD)0x0100;
						window_y1 |= (WORD)dat;
						break;
				case 6:	/* YEBhEGhAhX() */
						window_y2 &= (WORD)0x00ff;
						window_y2 |= (WORD)((dat & 0x01) << 8);
						break;
				case 7:	/* YEBhEGhAhX() */
						window_y2 &= (WORD)0x0100;
						window_y2 |= (WORD)dat;
						break;
				default:
						ASSERT(FALSE);
			}

			check_window_open();
			return TRUE;
#endif
	}

	return FALSE;
}

/*
 *	fBXvC
 *	Z[u
 */
BOOL FASTCALL display_save(int fileh)
{
	if (!file_bool_write(fileh, crt_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, vrama_flag)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_bool_write(fileh, subnmi_flag)) {
		return FALSE;
	}
#endif
	if (!file_bool_write(fileh, vsync_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, blank_flag)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, vram_offset_flag)) {
		return FALSE;
	}
#if XM7_VER >= 2
	if (!file_word_write(fileh, vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_write(fileh, vram_offset[1])) {
		return FALSE;
	}
	if (!file_word_write(fileh, crtc_offset[0])) {
		return FALSE;
	}
	if (!file_word_write(fileh, crtc_offset[1])) {
		return FALSE;
	}

	if (!file_byte_write(fileh, vram_active)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, vram_display)) {
		return FALSE;
	}
#else
	if (!file_word_write(fileh, vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_write(fileh, crtc_offset[0])) {
		return FALSE;
	}
#endif

	/* Ver6g */
	if (!file_word_write(fileh, blank_count)) {
		return FALSE;
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (!file_byte_write(fileh, subram_vrambank)) {
		return FALSE;
	}
	if (!file_word_write(fileh, sub_kanji_addr)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, sub_kanji_bank)) {
		return FALSE;
	}

	if (!file_word_write(fileh, window_x1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dx1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_y1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dy1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_x2)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dx2)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_y2)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dy2)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, window_open)) {
		return FALSE;
	}

	if (!file_byte_write(fileh, block_active)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, block_display)) {
		return FALSE;
	}
#endif

#if XM7_VER == 1 && defined(L4CARD)
	/* XM7 V1.1 / FM-77L4eLXgVRAM܂ */
	if (!file_bool_write(fileh, width40_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, cursor_lsb)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, text_blink)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, cursor_blink)) {
		return FALSE;
	}
	if (!file_word_write(fileh, text_start_addr)) {
		return FALSE;
	}
	if (!file_word_write(fileh, cursor_addr)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, enable_400line)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, workram_select)) {
		return FALSE;
	}
	if (!file_word_write(fileh, sub_kanji_addr)) {
		return FALSE;
	}

	if (!file_byte_write(fileh, crtc_regnum)) {
		return FALSE;
	}
	if (!file_write(fileh, crtc_register, 0x20)) {
		return FALSE;
	}
#endif

	/* Ver9.18/Ver7.18/Ver3.08g */
	if (!file_dword_write(fileh, now_raster)) {
		return FALSE;
	}

	/* Ver3.10g */
#if XM7_VER == 1 && defined(L4CARD)
	if (!file_byte_write(fileh, 0xff)) {
		return FALSE;
	}
#endif

	return TRUE;
}

/*
 *	fBXvC
 *	[h
 */
BOOL FASTCALL display_load(int fileh, int ver)
{
#if XM7_VER == 1 && defined(L4CARD)
	BYTE tmp;
#endif

	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &crt_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &vrama_flag)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_bool_read(fileh, &subnmi_flag)) {
		return FALSE;
	}
#endif
	if (!file_bool_read(fileh, &vsync_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &blank_flag)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &vram_offset_flag)) {
		return FALSE;
	}
#if XM7_VER >= 2
	if (!file_word_read(fileh, &vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &vram_offset[1])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &crtc_offset[0])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &crtc_offset[1])) {
		return FALSE;
	}

	if (!file_byte_read(fileh, &vram_active)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &vram_display)) {
		return FALSE;
	}

	/* Cxg */
	schedule_handle(EVENT_SUBTIMER, subcpu_event);
	schedule_handle(EVENT_VSYNC, display_vsync);
	schedule_handle(EVENT_BLANK, display_blank);
#else
	if (!file_word_read(fileh, &vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &crtc_offset[0])) {
		return FALSE;
	}

	/* Cxg */
	schedule_handle(EVENT_SUBTIMER, subcpu_event);
	schedule_handle(EVENT_VSYNC, display_vsync);
#endif

	/* Ver6g */
#if XM7_VER >= 2
	if (ver >= 600) {
#else
	if (ver >= 300) {
#endif
		if (!file_word_read(fileh, &blank_count)) {
			return FALSE;
		}
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (ver >= 800) {
		if (!file_byte_read(fileh, &subram_vrambank)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &sub_kanji_addr)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &sub_kanji_bank)) {
			return FALSE;
		}

		if (!file_word_read(fileh, &window_x1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dx1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_y1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dy1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_x2)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dx2)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_y2)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dy2)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &window_open)) {
			return FALSE;
		}

		if (!file_byte_read(fileh, &block_active)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &block_display)) {
			return FALSE;
		}
	}
	else {
		subram_vrambank = 0;
		sub_kanji_addr = 0;
		sub_kanji_bank = FALSE;

		window_x1 = 0;
		window_dx1 = 0;
		window_x2 = 0;
		window_dx2 = 0;
		window_y1 = 0;
		window_dy1 = 0;
		window_y2 = 0;
		window_dy2 = 0;
		window_open = FALSE;

		block_active = 0;
		block_display = 0;
	}
#endif

#if XM7_VER == 1 && defined(L4CARD)
	/* XM7 V1.1 / FM-77L4eLXgVRAM܂ */
	if (!file_bool_read(fileh, &width40_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &cursor_lsb)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &text_blink)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &cursor_blink)) {
		return FALSE;
	}
	if (!file_word_read(fileh, &text_start_addr)) {
		return FALSE;
	}
	if (!file_word_read(fileh, &cursor_addr)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &enable_400line)) {
		return FALSE;
	}
	/* 400CJ[h`FbN */
	if (enable_400line && !detect_400linecard) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &workram_select)) {
		return FALSE;
	}
	if (!file_word_read(fileh, &sub_kanji_addr)) {
		return FALSE;
	}

	if (!file_byte_read(fileh, &crtc_regnum)) {
		return FALSE;
	}
	if (!file_read(fileh, crtc_register, 0x20)) {
		return FALSE;
	}

	/* Cxg */
	schedule_handle(EVENT_TEXT_BLINK, display_text_blink);
#endif

	/* Ver9.18/Ver7.18/Ver3.08g */
#if XM7_VER >= 3
	if ((ver >= 918) || ((ver >= 718) && (ver <= 799))) {
#elif XM7_VER >= 2
	if ((ver >= 718) && (ver <= 799)) {
#else
	if (ver >= 308) {
#endif
		if (!file_dword_read(fileh, (DWORD *)&now_raster)) {
			return FALSE;
		}
	}
	else {
		now_raster = 0;
	}

	/* Ver3.10g */
#if XM7_VER == 1 && defined(L4CARD)
	if (ver >= 310) {
		if (!file_byte_read(fileh, &tmp)) {
			return FALSE;
		}
	}
#endif

	/* |C^\ */
	display_setpointer(TRUE);
	display_setup();

	return TRUE;
}
