/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2020 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2020 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ DMAC(HD6844) AV40dlΉ ]
 *
 *	RHG
 *	  2001.05.08	WX^̂S`lΉ/f[^`FCΉ
 *					HALTTCNX`[]̃NbN΂ǉ
 *					]BCR0ɂꍇ̋C
 *	  2001.05.09	Xe[gt@Cݏ̐V@\Ή(o[W9p)
 *	  2001.11.15	]IĂBUSYtOȂC
 *					]ITxRQrbgɗC
 *					DENDrbg[hANZXŃNA悤ɏC
 *					̑Aׂ̋@ɍ킹ďC
 *					AV40dlΉłƃ\[X𓝍
 *	  2002.02.12	BCRɂ钆fBUSYtOȂC
 *	  2002.02.16	BCRɂ钆fDENDtOȂC
 *	  2002.02.19	IRQςȂɂȂC(ccc)
 *	  2002.05.09	DMA]tOV
 *	  2002.05.11	FDCR}hs100sDMA]Jn悤ɕύX
 *	  2002.07.17	荞ݐ䃌WX^ bit7̋C
 *	  2002.12.09	FDCR}hs]Jn܂ł̃EFCg50sɕύX
 *	  2004.08.16	o[Xg]̎܂Ƃɂ
 *	  2020.11.22	FDCDRQM󂯎Ƀo[Xg[hLɂ
 *					悤ɏC
 */

#if XM7_VER >= 3

#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "xm7.h"
#include "device.h"
#include "mainetc.h"
#include "dmac.h"
#include "fdc.h"
#include "mmr.h"
#include "event.h"

/*
 *	O[o [N
 */
WORD dma_adr[4];						/* AhXWX^ */
WORD dma_bcr[4];						/* ]ꐔWX^ */
BYTE dma_chcr[4];						/* `l䃌WX^ */
BYTE dma_pcr;							/* D搧䃌WX^ */
BYTE dma_icr;							/* 荞ݐ䃌WX^ */
BYTE dma_dcr;							/* f[^`FC䃌WX^ */

BYTE dma_reg;							/* ݑIĂ郌WX^ԍ */
BOOL dma_flag;							/* DMA]stO */
BOOL dma_burst_transfer;				/* DMAo[Xg]stO */


/*
 *	vg^Cv錾
 */
static BOOL FASTCALL dmac_start_ch0(void);	/* DMA]JnCxg */


/*
 *	DMAC
 *	
 */
BOOL FASTCALL dmac_init(void)
{
	return TRUE;
}

/*
 *	DMAC
 *	N[Abv
 */
void FASTCALL dmac_cleanup(void)
{
}

/*
 *	DMAC
 *	Zbg
 */
void FASTCALL dmac_reset(void)
{
	int i;

	/* DMACWX^ */
	for (i=0; i<4; i++) {
		dma_adr[i] = 0xFFFF;
		dma_bcr[i] = 0xFFFF;
		dma_chcr[i] = 0x00;
	}
	dma_pcr = 0x00;
	dma_icr = 0x00;
	dma_dcr = 0x00;

	/* [N */
	dma_reg = 0x00;
	dma_flag = FALSE;
	dma_burst_transfer = FALSE;
}


/*
 *	DMAC
 *	]Jn
 */
void FASTCALL dmac_start(void)
{
	/* o[W`FbN */
	if (fm7_ver < 3) {
		return;
	}

	/* DMA]쒆łΉȂ */
	if (dma_flag) {
		return;
	}

	/* ]꒷WX^(BCR)`FbN */
	if (dma_bcr[0] == 0) {
		return;
	}

	/* DMAgptO(TxRQ)`FbN */
	if (!(dma_pcr & 0x01)) {
		return;
	}

	/* DMA]Jn Cxgݒ */
	schedule_setevent(EVENT_FDC_DMA, 50, dmac_start_ch0);
}

/*
 *	DMAC Ch.0(FDC)
 *	]JnCxg
 */
static BOOL FASTCALL dmac_start_ch0(void)
{
	/* Cxg폜 */
	schedule_delevent(EVENT_FDC_DMA);

	/* DMAX^[g */
	dma_flag = TRUE;
	dma_chcr[0] = (BYTE)((dma_chcr[0] & 0x0f) | 0x40);

	return TRUE;
}

/*
 *	DMAC Ch.0(FDC)
 *	DMA]
 */
void FASTCALL dmac_exec(void)
{
	BYTE dat;
	BYTE seg;

	/* TxRQ`FbN */
	if (!(dma_pcr & 0x01)) {
		return;
	}

	/* ̎_BCR0Ȃ]/荞ݔɏ𒆎~ */
	if (dma_bcr[0] == 0) {
		dma_flag = FALSE;
		dma_chcr[0] = (BYTE)((dma_chcr[0] & 0x0f) | 0x80);
		return;
	}

	/* FDCDRQ󂯁A] */
	fdc_readb(0xfd1f, &dat);
	if (!(dat & 0x80)) {
		if (dma_burst_transfer) {
			/* XPW[O̊֌WACCPUNbNi߂ */
			maincpu.total += (WORD)2;
		}
		return;
	}

	/* o[Xg[h̃`FbNȂ */
	if ((dma_chcr[0] & 0x02) && !dma_burst_transfer) {
		dma_burst_transfer = TRUE;
	}

	/* DMA]sBMMR͏ɃZOg0ɂȂ */
	seg = mmr_seg;
	mmr_seg = 0;

	if (dma_chcr[0] & 0x01) {
		/* 1:FDC (Write) */
		dat = mainmem_readb(dma_adr[0]);
		fdc_writeb(0xfd1b, dat);
	}
	else {
		/* 0:FDC (Read) */
		fdc_readb(0xfd1b, &dat);
		mainmem_writeb(dma_adr[0], dat);
	}

	/* MMRZOgA */
	mmr_seg = seg;

	/* AhXXV */
	if (dma_chcr[0] & 0x08) {
		/* AhXDOWN */
		dma_adr[0]--;
	}
	else {
		/* AhXUP */
		dma_adr[0]++;
	}

	/* CCPUNbN̈΂s */
	maincpu.total += (WORD)3;

	/* ]TCYXV */
	dma_bcr[0]--;

	/* ]I`FbN */
	if (dma_bcr[0] == 0) {
#ifdef DMAC_AV40
		if ((dma_dcr & 0x07) == 0x01) {
			/* f[^`FC */
			dma_adr[0] = dma_adr[3];
			dma_bcr[0] = dma_bcr[3];
			dma_bcr[3] = 0;
		}
		else {
			/* DMAI */
			dma_flag = FALSE;
			dma_burst_transfer = FALSE;
			dma_chcr[0] = (BYTE)((dma_chcr[0] & 0x0f) | 0x80);
			dma_dcr |= 0x10;

			/* 荞݂Cl[uȂA荞݂ */
			if (dma_icr & 0x01) {
				dma_icr |= 0x80;
				dma_irq_flag = TRUE;
				maincpu_irq();
			}
			return;
		}
#else
		/* DMAI */
		dma_flag = FALSE;
		dma_burst_transfer = FALSE;
		dma_chcr[0] = (BYTE)((dma_chcr[0] & 0x0f) | 0x80);
		dma_dcr |= 0x10;

		/* 荞݂Cl[uȂA荞݂ */
		if (dma_icr & 0x01) {
			dma_icr |= 0x80;
			dma_irq_flag = TRUE;
			maincpu_irq();
		}
		return;
#endif
	}
}

/*
 *	DMAC
 *	WX^ǂݍ
 */
static BYTE FASTCALL dmac_readreg(WORD addr)
{
	BYTE	tmp;

	switch (addr) {
#ifdef DMAC_AV40
		/* AhXWX^() */
		case 0x00:
		case 0x04:
		case 0x08:
		case 0x0c:
			return (BYTE)((dma_adr[addr>>2] >> 8) & 0xff);

		/* AhXWX^() */
		case 0x01:
		case 0x05:
		case 0x09:
		case 0x0d:
			return (BYTE)(dma_adr[addr>>2] & 0xff);

		/* ]ꐔWX^() */
		case 0x02:
		case 0x06:
		case 0x0a:
		case 0x0e:
			return (BYTE)((dma_bcr[addr>>2] >> 8) & 0xff);

		/* ]ꐔWX^() */
		case 0x03:
		case 0x07:
		case 0x0b:
		case 0x0f:
			return (BYTE)(dma_bcr[addr>>2] & 0xff);

		/* `l䃌WX^ */
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
			tmp = dma_chcr[addr-0x10];
			dma_chcr[addr-0x10] &= 0x7f;
			return tmp;
#else
		/* AhXWX^() */
		case 0x00:
			return (BYTE)((dma_adr[0] >> 8) & 0xff);

		/* AhXWX^() */
		case 0x01:
			return (BYTE)(dma_adr[0] & 0xff);

		/* ]ꐔWX^() */
		case 0x02:
			return (BYTE)((dma_bcr[0] >> 8) & 0xff);

		/* ]ꐔWX^() */
		case 0x03:
			return (BYTE)(dma_bcr[0] & 0xff);

		/* `l䃌WX^ */
		case 0x10:
			tmp = dma_chcr[0];
			dma_chcr[0] &= 0x7f;
			return tmp;
#endif

		/* D搧䃌WX^ */
		case 0x14:
			return dma_pcr;

		/* 荞ݐ䃌WX^ */
		case 0x15:
			tmp = (BYTE)(((dma_dcr >> 4) | 0x80) & dma_icr);
			dma_dcr &= 0x0f;

			/* IRQ */
			dma_icr &= (BYTE)~0x80;
			dma_irq_flag = FALSE;
			maincpu_irq();
			return tmp;

		/* f[^`FC䃌WX^ */
		case 0x16:
			return (BYTE)(dma_dcr & 0x0f);
	}

	/* ̑̃WX^̓fR[hĂȂ */
	return 0x00;
}

/*
 *	DMAC
 *	WX^
 */
static void FASTCALL dmac_writereg(WORD addr, BYTE dat)
{
	switch (addr) {
		/* AhXWX^() */
		case 0x00:
		case 0x04:
		case 0x08:
		case 0x0c:
			dma_adr[addr>>2] = (WORD)((dma_adr[addr>>2] & 0xff) | (dat << 8));
			return;

		/* AhXWX^() */
		case 0x01:
		case 0x05:
		case 0x09:
		case 0x0d:
			dma_adr[addr>>2] = (WORD)((dma_adr[addr>>2] & 0xff00) | dat);
			return;

		/* ]ꐔWX^() */
		case 0x02:
		case 0x06:
		case 0x0a:
		case 0x0e:
			dma_bcr[addr>>2] = (WORD)((dma_bcr[addr>>2] & 0xff) | (dat << 8));
			return;

		/* ]ꐔWX^() */
		case 0x03:
		case 0x07:
		case 0x0b:
		case 0x0f:
			dma_bcr[addr>>2] = (WORD)((dma_bcr[addr>>2] & 0xff00) | dat);
			return;

		/* `l䃌WX^ */
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
			dma_chcr[addr-0x10] = (BYTE)((dma_chcr[addr-0x10] & 0xc0) | (dat & 0x0f));
			return;

		/* D搧䃌WX^ */
		case 0x14:
			dma_pcr = (BYTE)(dat & 0x8f);
			return;

		/* 荞ݐ䃌WX^ */
		case 0x15:
			dma_icr = (BYTE)((dma_icr & 0x80) | (dat & 0x0f));
			return;

		/* f[^`FC䃌WX^ */
		case 0x16:
			dma_dcr = (BYTE)((dma_dcr & 0xf0) | (dat & 0x0f));
			return;
	}
}

/*
 *	DMAC
 *	PoCg擾
 */
BOOL FASTCALL dmac_readb(WORD addr,BYTE *dat)
{
	/* o[W`FbN */
	if (fm7_ver < 3) {
		return FALSE;
	}

	switch (addr) {
		/* DMACAhX */
		case 0xfd98:
			*dat = dma_reg;
			return TRUE;

		/* DMACf[^ */
		case 0xfd99:
			*dat = dmac_readreg(dma_reg);
			return TRUE;
	}

	return FALSE;
}

/*
 *	DMAC
 *	PoCg
 */
BOOL FASTCALL dmac_writeb(WORD addr, BYTE dat)
{
	/* o[W`FbN */
	if (fm7_ver < 3) {
		return FALSE;
	}

	switch (addr) {
		/* DMACAhX */
		case 0xfd98:
			dma_reg = (BYTE)(dat & 0x1f);
			return TRUE;

		/* DMACf[^ */
		case 0xfd99:
			dmac_writereg(dma_reg, dat);
			return TRUE;
	}

	return FALSE;
}

/*
 *	DMAC
 *	Z[u
 */
BOOL FASTCALL dmac_save(int fileh)
{
#ifdef DMAC_AV40
	int	i;
#endif

	if (!file_word_write(fileh, dma_adr[0])) {
		return FALSE;
	}
	if (!file_word_write(fileh, dma_bcr[0])) {
		return FALSE;
	}
	if (!file_byte_write(fileh, dma_chcr[0])) {
		return FALSE;
	}
	if (!file_byte_write(fileh, dma_pcr)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, dma_icr)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, dma_reg)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, dma_flag)) {
		return FALSE;
	}

	/* Ver9g */
	if (!file_byte_write(fileh, dma_dcr)) {
		return FALSE;
	}

	/* Ver912g */
	if (!file_bool_write(fileh, dma_burst_transfer)) {
		return FALSE;
	}

	/* Ver9gEAV40dl (40EXdlƂ̌݊ȂȂ̂Œ) */
#ifdef DMAC_AV40
	for (i=1;i<4;i++) {
		if (!file_word_write(fileh, dma_adr[i])) {
			return FALSE;
		}
		if (!file_word_write(fileh, dma_bcr[i])) {
			return FALSE;
		}
		if (!file_word_write(fileh, dma_chcr[i])) {
			return FALSE;
		}
	}
#endif

	return TRUE;
}

/*
 *	DMAC
 *	[h
 */
BOOL FASTCALL dmac_load(int fileh, int ver)
{
	int	i;

	/* o[W`FbN */
	if (ver < 800) {
		dmac_reset();
		return TRUE;
	}

	if (!file_word_read(fileh, &dma_adr[0])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &dma_bcr[0])) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &dma_chcr[0])) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &dma_pcr)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &dma_icr)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &dma_reg)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &dma_flag)) {
		return FALSE;
	}

	/* Ver9g */
	if (ver >= 900) {
		if (!file_byte_read(fileh, &dma_dcr)) {
			return FALSE;
		}

		/* Ver912g */
		if (ver >= 912) {
			if (!file_bool_read(fileh, &dma_burst_transfer)) {
				return FALSE;
			}
		}
#ifdef DMAC_AV40
		/* Ver9gEAV40dl (40EXdlƂ̌݊ȂȂ̂Œ) */
		for (i=1; i<4; i++) {
			if (!file_word_read(fileh, &dma_adr[i])) {
				return FALSE;
			}
			if (!file_word_read(fileh, &dma_bcr[i])) {
				return FALSE;
			}
			if (!file_byte_read(fileh, &dma_chcr[i])) {
				return FALSE;
			}
		}
#endif
	}
	else {
		dma_dcr = 0x08;
	}

	/* Ch1`3 */
#ifndef DMAC_AV40
	for (i=1; i<4; i++) {
		dma_adr[i] = 0xFFFF;
		dma_bcr[i] = 0xFFFF;
		dma_chcr[i] = 0x00;
	}
#endif

	return TRUE;
}

#endif	/* XM7_VER >= 3 */
