/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ tbs[fBXN Rg[(MB8877A) ]
 *
 *	RHG
 *	  2001.12.03		fBXNC[W̃}Eg̓t@CI[v
 *						܂̏ԂɂȂ悤ɕύX (townsł̂)
 *						V22DD̃fBXNC[W}Egł̂C
 *	  2001.12.09		2DDC[W2D[hœǂނƃgbN␳sȂ
 *						C
 *	  2002.02.09		ZN^̃wb_̂擪̂PoCg(gbNԍ)
 *						gbNf[^ɔfȂC (Y.Sato)
 *	  2002.02.26		D77t@C̃ZN^RECORD TYPEG[CRCG
 *						[ɔȂC (Apollo)
 *	  2002.04.25		TCh̔rbit0̂ݔr悤ɕύX
 *	  2002.05.03		2DD؂芷sɃgbN̍ēǂݍ݂s悤
 *						ɕύX
 *	  2002.05.06		gbNWX^EZN^WX^R}hsɏ
 *						̋C
 *						READ ADDRESSR}hsɓǂݏoIDtB[h̃g
 *						bNԍZN^WX^ɓ悤ɕύX
 *	  2002.05.24		fdc_readsecIDtB[h̃TChƃTChWX^
 *						rȂ悤ɕύX
 *	  2002.11.10		EFCg}EV[NɑΉ
 *	  2002.12.16		WRITE TRACKR}hsFORCE INTERRUPTR}h
 *						sďł؂ꍇɂf[^݂̏s
 *						ɕύX
 *	  2003.02.08		EFCg쎞̃V[NR}hłFDC荞݃^C~
 *						OC
 *	  2003.02.25		EFCgȂ쎞̃V[NnR}hłIRQ OnEFDC
 *						荞݃^C~OC
 *	  2003.03.15		Write TrackDELETED DATA MARKɑΉ
 *						Read TrackŃf[^OSYNC/DATA ADDRESS MARK
 *						YĂ̂C
 *	  2003.04.02		Read Track̏Ԃfdc_readyɔfȂC
 *	  2004.03.17		2DDx^C[WΉ
 *						2D/2DD/VFDt@C̃gbN␳C
 *	  2004.03.23		D77t@C̊gbNŃ~XĂ̂C
 *	  2010.07.08		SEEKR}hs̃gbNWX^ɃZbgl
 *						f[^WX^ɃZbglɕύX (OS-9 L1 V1.2 L1.2)
 *	  2010.07.26		u[gtOp~
 *	  2010.08.07		ꎞCWFNgꂽfBA݂ԂŃJg
 *						hCuȊOɃfBAZbgꂽɈꎞCWFN
 *						gIɉC
 *	  2010.11.21		t@C̐256oCg܂łɊɘa
 *						fBA}Eg̃t@CTCY`FbN
 *	  2012.10.11		JghCuɃ}EgD77t@C̃fB
 *						AύXۂɓgbNobt@Ă
 *						܂C
 *	  2017.11.28		V1/V2ł2DDC[WANZX(gbN̂)ɑΉ
 *	  2018.01.03		^Ť咣܂ɂEÛCRCvZASY
 *						ύX(Thanks for Toshio Fukui)
 */

#include <string.h>
#include <stdlib.h>
#include "xm7.h"
#include "device.h"
#include "fdc.h"
#include "crcgen.h"
#include "mainetc.h"
#if XM7_VER >= 3
#include "dmac.h"
#endif
#include "event.h"

/*
 *	O[o [N
 */
BYTE fdc_command;					/* FDCR}h */
BYTE fdc_status;					/* FDCXe[^X */
BYTE fdc_trkreg;					/* gbNWX^ */
BYTE fdc_secreg;					/* ZN^WX^ */
BYTE fdc_datareg;					/* f[^WX^ */
BYTE fdc_sidereg;					/* TChWX^ */
BYTE fdc_drvreg;					/* _hCu */
#if XM7_VER >= 2
BYTE fdc_dsenable;					/* DSCl[u */
#endif
#if XM7_VER >= 3
BYTE fdc_drvregP;					/* hCu */
#endif
BYTE fdc_motor;						/* [^ */
BYTE fdc_drqirq;					/* DRQIRQ */

BYTE fdc_cmdtype;					/* R}h^Cv */
WORD fdc_totalcnt;					/* g[^JE^ */
WORD fdc_nowcnt;					/* JgJE^ */
BYTE fdc_ready[FDC_DRIVES];			/* fB */
BOOL fdc_teject[FDC_DRIVES];		/* ꎞCWFNg */
BOOL fdc_writep[FDC_DRIVES];		/* CgveNg */
BYTE fdc_track[FDC_DRIVES];			/* gbN */

#if XM7_VER >= 3
BYTE fdc_logidrv;					/* _hCuԍ */
BYTE fdc_physdrv[FDC_DRIVES];		/* _/hCȗΉ */
BYTE fdc_2ddmode;					/* 2D[hI */
#endif

char fdc_fname[FDC_DRIVES][256+1];	/* t@C */
char fdc_name[FDC_DRIVES][FDC_MEDIAS][17];
BOOL fdc_fwritep[FDC_DRIVES];		/* CgveNg(t@Cx) */
BYTE fdc_header[FDC_DRIVES][0x2b0];	/* D77t@Cwb_ */
BYTE fdc_medias[FDC_DRIVES];		/* fBA */
BYTE fdc_media[FDC_DRIVES];			/* fBAZNg */
BYTE fdc_access[FDC_DRIVES];		/* ANZXLED */

#ifdef FDDSND
BOOL fdc_waitmode;					/* FDCANZXEFCg */
BOOL fdc_sound;						/* FDDV[NtO */
#endif


/*
 *	X^eBbN [N
 */
static BYTE fdc_buffer[0x2000];					/* f[^obt@ */
static BYTE *fdc_dataptr;						/* f[^|C^ */
static DWORD fdc_seekofs[FDC_DRIVES];			/* V[NItZbg */
static DWORD fdc_secofs[FDC_DRIVES];			/* ZN^ItZbg */
static DWORD fdc_foffset[FDC_DRIVES][FDC_MEDIAS];
static WORD fdc_trklen[FDC_DRIVES];				/* gbNf[^ */
static BOOL fdc_seekvct;						/* V[N(Trk0:TRUE) */
static BYTE fdc_indexcnt;						/* INDEXz[ JE^ */
#ifdef FDDSND
static BOOL fdc_wait;							/* EFCg[hstO */
static int fdc_seek_track;						/* waitmodepV[NJE^ */
#endif


/*
 *	Xebv[ge[u
 */
#ifdef FDDSND
static const int fdc_steprate[4] = { 6000, 12000, 20000, 30000 };
#endif


/*
 *	vg^Cv錾
 */
static void FASTCALL fdc_readbuf(int drive);	/* PgbNǂݍ */
static BOOL FASTCALL fdc_lost_event(void);		/* LOST DATACxg */


/*
 *	FDC
 *	
 */
BOOL FASTCALL fdc_init(void)
{
	int i;

	/* tbs[t@C֌WZbg */
	for (i=0; i<FDC_DRIVES; i++) {
		fdc_ready[i] = FDC_TYPE_NOTREADY;
		fdc_teject[i] = FALSE;
		fdc_fwritep[i] = FALSE;
		fdc_medias[i] = 0;
	}

	/* t@CItZbgSăNA */
	memset(fdc_foffset, 0, sizeof(fdc_foffset));

	/* EFCg}[htO */
#ifdef FDDSND
	fdc_waitmode = FALSE;
	fdc_sound = FALSE;
	fdc_wait = FALSE;
#endif

	/* CRCvZe[u쐬 */
	crcgen_init();

	return TRUE;
}

/*
 *	FDC
 *	N[Abv
 */
void FASTCALL fdc_cleanup(void)
{
	int i;

	/* tbs[t@C֌WZbg */
	for (i=0; i<FDC_DRIVES; i++) {
		fdc_ready[i] = FDC_TYPE_NOTREADY;
	}
}

/*
 *	FDC
 *	Zbg
 */
void FASTCALL fdc_reset(void)
{
#if XM7_VER >= 3
	int i;
#endif

	/* FDCWX^Zbg */
	fdc_command = 0xff;
	fdc_status = 0;
	fdc_trkreg = 0;
	fdc_secreg = 0;
	fdc_datareg = 0;
	fdc_sidereg = 0;
	fdc_drvreg = 0;
#if XM7_VER >= 2
	fdc_dsenable = 0x00;
#endif

#if XM7_VER >= 3
	fdc_drvregP = 0;
#endif
	fdc_motor = 0;

#if XM7_VER >= 3
	fdc_logidrv = 0;
	fdc_2ddmode = FALSE;

	/* _hCuhCuɐݒ */
	for (i=0; i<FDC_DRIVES; i++) {
		fdc_physdrv[i] = (BYTE)i;
	}
#endif

	fdc_cmdtype = 0;
	fdc_seekvct = 0;
	memset(fdc_track, 0, sizeof(fdc_track));
	fdc_dataptr = NULL;
	memset(fdc_access, 0, sizeof(fdc_access));

	/* f[^obt@֓ǂݍ */
	fdc_readbuf(fdc_drvreg);
}

/*-[ t@CǗ ]---------------------------------------------------------*/

/*
 *	Read Trackf[^쐬
 */
static void FASTCALL fdc_make_track(void)
{
	int i;
	int j;
	int gap3;
	int track;
	WORD count;
	WORD secs;
	WORD size;
	BOOL flag;
	BYTE *p;
	BYTE *q;
	BOOL ddm;
	int max_track;

	/* AtH[}bg`FbN */
	flag = FALSE;
	if (fdc_ready[fdc_drvreg] != FDC_TYPE_D77) {
		/* 2D/2DD/VFDt@C̃AtH[}bg`FbN͋ */
		if (fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) {
			max_track = 80;
		}
		else {
			max_track = 40;
		}

		if (fdc_track[fdc_drvreg] >= max_track) {
			/* AtH[}bg */
			flag = TRUE;
		}
#if XM7_VER >= 3
		if (((fdc_ready[fdc_drvreg] != FDC_TYPE_2DD) && fdc_2ddmode) &&
			((fdc_track[fdc_drvreg] % 2) == 1)) {
			/* 2DC[W2DDANZXAgbN̓AtH[}bg */
			flag = TRUE;
		}
#endif
	}
	else {
		if ((fdc_buffer[4] == 0) && (fdc_buffer[5] == 0)) {
			/* AtH[}bg */
			flag = TRUE;
		}
#if XM7_VER >= 3
		if (((fdc_header[fdc_drvreg][0x001b] == 0x00) && fdc_2ddmode) &&
			((fdc_track[fdc_drvreg] % 2) == 1)) {
			/* 2DC[W2DDANZXAgbN̓AtH[}bg */
			flag = TRUE;
		}
#endif
	}

	/* AtH[}bgȂA_f[^쐬 */
	if (flag) {
		p = fdc_buffer;
		for (i=0; i<0x1800; i++) {
			*p++ = calc_rand();
		}

		/* f[^|C^AJE^ݒ */
		fdc_dataptr = fdc_buffer;
		fdc_totalcnt = 0x1800;
		fdc_nowcnt = 0;
		return;
	}

	/* ZN^ZoAf[^ړ */
	if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) ||
		(fdc_ready[fdc_drvreg] == FDC_TYPE_2DD)) {
		secs = 16;
		q = &fdc_buffer[0x1000];
		memcpy(q, fdc_buffer, 0x1000);
	}
	else if (fdc_ready[fdc_drvreg] == FDC_TYPE_VFD) {
#if XM7_VER >= 3
		if (fdc_2ddmode) {
			/* fBA^Cv(2D) != hCu[h(2DD) */
			track = (fdc_track[fdc_drvreg] >> 1);
		}
		else {
			/* fBA^Cv == hCu[h ␳Ȃ */
			track = fdc_track[fdc_drvreg];
		}
#else
		track = fdc_track[fdc_drvreg];
#endif
		count = fdc_header[fdc_drvreg][track * 6 + 4];
		if (count == 0) {
			count = 128;
		}
		else {
			count *= (WORD)256;
		}
		count *= (WORD)fdc_header[fdc_drvreg][track * 6 + 5];

		/* f[^Rs[ */
		q = &fdc_buffer[0x2000 - count];
		for (j = (count - 1); j >= 0; j--) {
			q[j] = fdc_buffer[j];
		}
	}
	else {
		secs = (WORD)(fdc_buffer[0x0005] * 256);
		secs += (WORD)(fdc_buffer[0x0004]);
		count = 0;
		/* SZN^܂āATCYv */
		for (j=0; j<secs; j++) {
			p = &fdc_buffer[count];
			count += (WORD)((p[0x000f] * 256 + p[0x000e]));
			count += (WORD)0x10;
		}
		/* f[^Rs[ */
		q = &fdc_buffer[0x2000 - count];
		for (j = (count - 1); j >= 0; j--) {
			q[j] = fdc_buffer[j];
		}
	}

	/* GAP3 */
	if (secs <= 5) {
		gap3 = 0x74;
	}
	else {
		if (secs <= 10) {
			gap3 = 0x54;
		}
		else {
			if (secs <= 16) {
				gap3 = 0x33;
			}
			else {
				gap3 = 0x10;
			}
		}
	}

	/* obt@ */
	p = fdc_buffer;
	count = 0;

	/* GAP0 */
	for (i=0; i<80; i++) {
		*p++ = 0x4e;
	}
	count += (WORD)80;

	/* SYNC */
	for (i=0; i<12; i++) {
		*p++ = 0;
	}
	count += (WORD)12;

	/* INDEX MARK */
	*p++ = 0xc2;
	*p++ = 0xc2;
	*p++ = 0xc2;
	*p++ = 0xfc;
	count += (WORD)4;

	/* GAP1 */
	for (i=0; i<50; i++) {
		*p++ = 0x4e;
	}
	count += (WORD)50;

	/* ZN^[v */
	for (j=0; j<secs; j++) {
		/* SYNC */
		for (i=0; i<12; i++) {
			*p++ = 0;
		}
		count += (WORD)12;

		/* ID ADDRESS MARK */
		p[0] = 0xa1;
		p[1] = 0xa1;
		p[2] = 0xa1;
		p[3] = 0xfe;

		/* ID */
		if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) ||
			(fdc_ready[fdc_drvreg] == FDC_TYPE_2DD)) {
#if XM7_VER >= 3
			if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) && fdc_2ddmode) {
				/* fBA^Cv(2D) != hCu[h(2DD) */
				p[4] = (BYTE)(fdc_track[fdc_drvreg] >> 1);
			}
			else if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) && !fdc_2ddmode) {
				/* fBA^Cv(2DD) != hCu[h(2D) */
				p[4] = (BYTE)(fdc_track[fdc_drvreg] << 1);
			}
			else {
				/* fBA^Cv == hCu[h ␳Ȃ */
				p[4] = fdc_track[fdc_drvreg];
			}
#else
			if (fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) {
				/* fBA^Cv(2DD) != hCu[h(2D) */
				p[4] = (BYTE)(fdc_track[fdc_drvreg] << 1);
			}
			else {
				/* fBA^Cv == hCu[h ␳Ȃ */
				p[4] = fdc_track[fdc_drvreg];
			}
#endif
			p[5] = fdc_sidereg;
			p[6] = (BYTE)(j + 1);
			p[7] = 1;
			size = 0x100;
			ddm = FALSE;
		}
		else if (fdc_ready[fdc_drvreg] == FDC_TYPE_VFD) {
#if XM7_VER >= 3
			if (fdc_2ddmode) {
				/* fBA^Cv(2D) != hCu[h(2DD) */
				p[4] = (BYTE)(fdc_track[fdc_drvreg] >> 1);
			}
			else {
				/* fBA^Cv == hCu[h ␳Ȃ */
				p[4] = fdc_track[fdc_drvreg];
			}
#else
			p[4] = fdc_track[fdc_drvreg];
#endif
			p[5] = fdc_sidereg;
			p[6] = (BYTE)(j + 1);
			p[7] = fdc_header[fdc_drvreg][p[4] * 6 + 4];
			if (p[7] == 0) {
				size = 128;
			}
			else {
				size = (WORD)(p[7] * 256);
			}
			ddm = FALSE;
		}
		else {
			memcpy(&p[4], q, 4);
			size = (WORD)(q[0x000f] * 256 + q[0x000e]);
			if (q[0x0007] != 0x00) {
				ddm = TRUE;
			}
			else {
				ddm = FALSE;
			}
			q += 0x0010;
		}
		calc_crc(p, 8);
		p += (8 + 2);
		count += (WORD)(8 + 2);

		/* GAP2 */
		for (i=0; i<22; i++) {
			*p++ = 0x4e;
		}
		count += (WORD)22;

		/* SYNC */
		for (i=0; i<12; i++) {
			*p++ = 0;
		}
		count += (WORD)12;

		/* DATA ADDRESS MARK */
		p[0] = 0xa1;
		p[1] = 0xa1;
		p[2] = 0xa1;
		if (ddm) {
			/* DELETED DATA MARK */
			p[3] = 0xf8;
		}
		else {
			/* DATA MARK */
			p[3] = 0xfb;
		}

		/* f[^ */
		memcpy(&p[4], q, size);
		q += size;
		calc_crc(p, size + 4);
		p += (size + 4 + 2);
		count += (WORD)(size + 4 + 2);

		/* GAP3 */
		for (i=0; i<gap3; i++) {
			*p++ = 0x4e;
		}
		count += (WORD)gap3;
	}

	/* GAP4 */
	j = (0x1800 - count);
	if (j < 0x1800) {
		for (i=0; i<j; i++) {
			*p++ = 0x4e;
		}
		count += (WORD)j;
	}

	/* f[^|C^AJE^ݒ */
	fdc_dataptr = fdc_buffer;
	fdc_totalcnt = count;
	fdc_nowcnt = 0;
}

/*
 *	IDtB[hobt@ɍ
 *	JE^Af[^|C^ݒ
 */
static void FASTCALL fdc_makeaddr(int index)
{
	int i;
	BYTE *p;
	WORD offset;
	WORD size;

	/* ]̂߂̃e|obt@́Aʏobt@ */
	/* ŌׂĐ݂ */
	p = &fdc_buffer[0x1ff0];

	/* ID ADDRESS MARK */
	p[0] = 0xa1;
	p[1] = 0xa1;
	p[2] = 0xa1;
	p[3] = 0xfe;

	if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) ||
		(fdc_ready[fdc_drvreg] == FDC_TYPE_2DD)) {
#if XM7_VER >= 3
		/* 2D/2DD̏ꍇAC,H,R,N͊m肷 */
		if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) && fdc_2ddmode) {
			/* fBA^Cv(2D) != hCu[h(2DD) */
			p[4] = (BYTE)(fdc_track[fdc_drvreg] >> 1);
		}
		else if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) && !fdc_2ddmode) {
			/* fBA^Cv(2DD) != hCu[h(2D) */
			p[4] = (BYTE)(fdc_track[fdc_drvreg] << 1);
		}
		else {
			/* fBA^Cv == hCu[h ␳Ȃ */
			p[4] = fdc_track[fdc_drvreg];
		}
#else
		if (fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) {
			/* fBA^Cv(2DD) != hCu[h(2D) */
			p[4] = (BYTE)(fdc_track[fdc_drvreg] << 1);
		}
		else {
			/* fBA^Cv == hCu[h ␳Ȃ */
			p[4] = fdc_track[fdc_drvreg];
		}
#endif
		p[5] = fdc_sidereg;
		p[6] = (BYTE)(index + 1);
		p[7] = 1;
	}
	else if (fdc_ready[fdc_drvreg] == FDC_TYPE_VFD) {
		/* VFD̏ꍇAC,H,R͊mAN̓wb_擾 */
#if XM7_VER >= 3
		if (fdc_2ddmode) {
			/* fBA^Cv(2D) != hCu[h(2DD) */
			p[4] = (BYTE)(fdc_track[fdc_drvreg] >> 1);
		}
		else {
			/* fBA^Cv == hCu[h ␳Ȃ */
			p[4] = fdc_track[fdc_drvreg];
		}
#else
		p[4] = fdc_track[fdc_drvreg];
#endif
		p[5] = fdc_sidereg;
		p[6] = (BYTE)(index + 1);
		p[7] = fdc_header[fdc_drvreg][p[0] * 6 + 4];
	}
	else {
		/* obt@ړĨZN^܂Ői߂ */
		offset = 0;
		i = 0;
		while (i < index) {
			/* ZN^TCY擾 */
			size = fdc_buffer[offset + 0x000f];
			size *= (WORD)256;
			size |= fdc_buffer[offset + 0x000e];

			/* ̃ZN^֐i߂ */
			offset += size;
			offset += (WORD)0x10;

			i++;
		}

		/* C,H,R,NRs[ */
		memcpy(&p[4], &fdc_buffer[offset], 4);
	}

	/* CRC */
	calc_crc(p, 8);

	/* f[^|C^AJE^ݒ */
	fdc_dataptr = &fdc_buffer[0x1ff4];
	fdc_totalcnt = 6;
	fdc_nowcnt = 0;

	/* ŁAZN^WX^ɃgbNԍݒ */
	fdc_secreg = p[4];
}

/*
 *	CfbNXJE^̃ZN^ֈڂ
 */
static int FASTCALL fdc_next_index(void)
{
	int max_track;
	int track;
	int secs;

	ASSERT(fdc_ready[fdc_drvreg] != FDC_TYPE_NOTREADY);

	/* fBXN^Cv`FbN */
	if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) ||
		(fdc_ready[fdc_drvreg] == FDC_TYPE_2DD)) {
		/* 2D/2DDȂ16ZN^Œ */
		fdc_indexcnt = (BYTE)((fdc_indexcnt + 1) & 0x0f);
		track = fdc_track[fdc_drvreg];
#if XM7_VER >= 3
		if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) && fdc_2ddmode) {
			/* fBA^Cv(2D) && hCu[h(2DD) */
			track >>= 1;
		}
		else if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) && !fdc_2ddmode) {
			/* fBA^Cv(2DD) && hCu[h(2D) */
			track <<= 1;
		}
#else
		if (fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) {
			/* fBA^Cv(2DD) && hCu[h(2D) */
			track <<= 1;
		}
#endif

#if XM7_VER >= 3
		if (fdc_2ddmode) {
			max_track = 80;
		}
		else {
			max_track = 40;
		}
#else
		max_track = 40;
#endif
		if (track >= max_track) {
			return -1;
		}
		return fdc_indexcnt;
	}

	/* D77/VFD */
	ASSERT( (fdc_ready[fdc_drvreg] == FDC_TYPE_D77) ||
			(fdc_ready[fdc_drvreg] == FDC_TYPE_VFD));

	if (fdc_ready[fdc_drvreg] == FDC_TYPE_VFD) {
		track = fdc_track[fdc_drvreg];
#if XM7_VER >= 3
		if (fdc_2ddmode) {
			track >>= 1;
		}
#endif
		secs = fdc_header[fdc_drvreg][track * 6 + 5];
	}
	else if (fdc_ready[fdc_drvreg] == FDC_TYPE_D77) {
		secs = fdc_buffer[0x0005];
		secs *= 256;
		secs |= fdc_buffer[0x0004];
	}
	if (secs == 0) {
		/* AtH[}bg */
		fdc_indexcnt = (BYTE)((fdc_indexcnt + 1) & 0x0f);
		return -1;
	}
	else {
		fdc_indexcnt++;
		if (fdc_indexcnt >= secs) {
			fdc_indexcnt = 0;
		}
		return fdc_indexcnt;
	}
}

/*
 *	ID}[NT
 */
static BOOL FASTCALL fdc_idmark(WORD *p)
{
	WORD offset;
	BYTE dat;

	/* A1 A1 A1 FEF5 F5 F5 FE */
	offset = *p;

	while (offset < fdc_totalcnt) {
		dat = fdc_buffer[offset++];
		if ((dat != 0xa1) && (dat != 0xf5)) {
			continue;
		}
		dat = fdc_buffer[offset++];
		if ((dat != 0xa1) && (dat != 0xf5)) {
			continue;
		}
		dat = fdc_buffer[offset++];
		if ((dat != 0xa1) && (dat != 0xf5)) {
			continue;
		}
		dat = fdc_buffer[offset++];
		if (dat == 0xfe) {
			*p = offset;
			return TRUE;
		}
	}

	*p = offset;
	return FALSE;
}

/*
 *	f[^}[NT
 */
static BOOL FASTCALL fdc_datamark(WORD *p, BOOL *deleted_mark)
{
	WORD offset;
	BYTE dat;

	/* data mark : A1 A1 A1 FBF5 F5 F5 FB */
	/* deleted data mark : A1 A1 A1 F8F5 F5 F5 F8 */
	offset = *p;

	while (offset < fdc_totalcnt) {
		dat = fdc_buffer[offset++];
		if ((dat != 0xa1) && (dat != 0xf5)) {
			continue;
		}
		dat = fdc_buffer[offset++];
		if ((dat != 0xa1) && (dat != 0xf5)) {
			continue;
		}
		dat = fdc_buffer[offset++];
		if ((dat != 0xa1) && (dat != 0xf5)) {
			continue;
		}
		dat = fdc_buffer[offset++];
		if ((dat == 0xfb) || (dat == 0xf8)) {
			*p = offset;
			if (dat == 0xfb) {
				/* 0xFB : DATA MARK */
				*deleted_mark = FALSE;
			}
			else {
				/* 0xF8 : DELETED DATA MARK */
				*deleted_mark = TRUE;
			}
			return TRUE;
		}
	}

	*p = offset;
	return FALSE;
}

/*
 *	gbNݏI
 */
static BOOL FASTCALL fdc_writetrk(void)
{
	int total;
	int sectors;
	WORD offset;
	WORD seclen;
	WORD writep;
	int i;
	int handle;
	BOOL ddm;

	/*  */
	total = 0;
	sectors = 0;

	/* ZN^ƁAf[^̃g[^TCY𐔂 */
	offset = 0;
	while (offset < fdc_totalcnt) {
		/* ID}[NT */
		if (!fdc_idmark(&offset)) {
			break;
		}
		/* C,H,R,N̎$F7 */
		offset += (WORD)4;
		if (offset >= fdc_totalcnt) {
			return FALSE;
		}
		if (fdc_buffer[offset] != 0xf7) {
			return FALSE;
		}
		offset++;
		/* f[^}[NT */
		if (!fdc_datamark(&offset, &ddm)) {
			return FALSE;
		}
		/* OXvZA$F7T */
		seclen = 0;
		while(offset < fdc_totalcnt) {
			if (fdc_buffer[offset] == 0xf7) {
				break;
			}
			offset++;
			seclen++;
		}
		if (offset >= fdc_totalcnt) {
			return FALSE;
		}
		/* ZN^ok */
		total += seclen;
		sectors++;
		offset++;
	}

	/* 2D/2DDfBȀꍇAtotal=0x1000, sectors=0x10K{ */
	if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) ||
		(fdc_ready[fdc_drvreg] == FDC_TYPE_2DD)) {
		/* total, sectorš */
		if (total != 0x1000) {
			return FALSE;
		}
		if (sectors != 16) {
			return FALSE;
		}

		/* {C,H,NȂǃ`FbNׂ */
		return TRUE;
	}

	/* VFDfBȀꍇA܂ */
	if (fdc_ready[fdc_drvreg] == FDC_TYPE_VFD) {
		/* {C,H,NȂǃ`FbNׂ */
		return TRUE;
	}

	/* ZN^Ƃ0x10ԂA]vɂ */
	if ((total + (sectors * 0x10)) > fdc_trklen[fdc_drvreg]) {
		return FALSE;
	}

	/* ޕKvȂꍇ͐I */
	if ((sectors == 0) && (total == 0)) {
		return TRUE;
	}

	/* ܂邱Ƃ킩̂ŁAf[^쐬 */
	writep = 0;
	offset = 0;
	for (i=0; i<sectors; i++) {
		/* ID}[N */
		fdc_idmark(&offset);

		/* 0x10wb_̍쐬 */
		fdc_buffer[writep++] = fdc_buffer[offset++];
		fdc_buffer[writep++] = fdc_buffer[offset++];
		fdc_buffer[writep++] = fdc_buffer[offset++];
		fdc_buffer[writep++] = fdc_buffer[offset++];
		fdc_buffer[writep++] = (BYTE)(sectors & 0xff);
		fdc_buffer[writep++] = (BYTE)(sectors >> 8);
		fdc_buffer[writep++] = 0x00;
		offset++;

		/* f[^}[N̏ */
		fdc_datamark(&offset, &ddm);
		if (ddm) {
			fdc_buffer[writep++] = 0x10;
		}
		else {
			fdc_buffer[writep++] = 0x00;
		}

		/* U[uGANA */
		/* ZN^OX͌ŏ */
		memset(&fdc_buffer[writep], 0, 8);
		writep += (WORD)8;

		/* OX𐔂Rs[ */
		seclen = 0;
		while (fdc_buffer[offset] != 0xf7) {
			fdc_buffer[writep++] = fdc_buffer[offset++];
			seclen++;
		}
		offset++;

		/* ZN^OXݒ */
		fdc_buffer[writep - seclen - 2] = (BYTE)(seclen & 0xff);
		fdc_buffer[writep - seclen - 1] = (BYTE)(seclen >> 8);
	}

	/* t@CɃf[^ */
	handle = file_open(fdc_fname[fdc_drvreg], OPEN_RW);
	if (handle == -1) {
		return FALSE;
	}
	if (!file_seek(handle, fdc_seekofs[fdc_drvreg])) {
		file_close(handle);
		return FALSE;
	}
	if (!file_write(handle, fdc_buffer, (sectors * 0x10) + total)) {
		file_close(handle);
		return FALSE;
	}
	file_close(handle);

	/* I */
	return TRUE;
}

/*
 *	ZN^ݏI
 */
static BOOL FASTCALL fdc_writesec(void)
{
	DWORD offset;
	int handle;

	/* assert */
	ASSERT(fdc_drvreg < FDC_DRIVES);
	ASSERT(fdc_ready[fdc_drvreg] != FDC_TYPE_NOTREADY);
	ASSERT(fdc_dataptr);
	ASSERT(fdc_totalcnt > 0);

	/* ItZbgZo */
	offset = fdc_seekofs[fdc_drvreg];
	offset += fdc_secofs[fdc_drvreg];

	/*  */
	handle = file_open(fdc_fname[fdc_drvreg], OPEN_RW);
	if (handle == -1) {
		return FALSE;
	}
	if (!file_seek(handle, offset)) {
		file_close(handle);
		return FALSE;
	}
	if (!file_write(handle, fdc_dataptr, fdc_totalcnt)) {
		file_close(handle);
		return FALSE;
	}
	file_close(handle);

	return TRUE;
}

/*
 *	gbNAZN^ATChƈvZN^
 *	JE^Af[^|C^ݒ
 */
static BYTE FASTCALL fdc_readsec(BYTE track, BYTE sector, BYTE side, BOOL sidecmp)
{
	int secs;
	int	len;
	int i;
	WORD offset;
	WORD size;
	BYTE stat;
	DWORD vfdoffset;
	int fdctrack;

	/* assert */
	ASSERT(fdc_drvreg < FDC_DRIVES);
	ASSERT(fdc_ready[fdc_drvreg] != FDC_TYPE_NOTREADY);

	/* wb_̂gbNԍ(rp)ݒ */
	fdctrack = fdc_track[fdc_drvreg];

	/* 2D/2DDt@C̏ꍇ */
	if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) ||
		(fdc_ready[fdc_drvreg] == FDC_TYPE_2DD)) {
#if XM7_VER >= 3
		if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) && fdc_2ddmode) {
			/* fBA^Cv(2D) != hCu[h(2DD) */
			if ((fdctrack % 2) == 1) {
				/* 2DC[W2DDANZXAgbNANZX̓G[ */
				return FDC_ST_RECNFND;
			}
			fdctrack = (BYTE)(fdctrack >> 1);
		}
		else if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) && !fdc_2ddmode) {
			/* fBA^Cv(2DD) != hCu[h(2D) */
			fdctrack = (BYTE)(fdctrack << 1);
		}
#else
		if (fdc_ready[fdc_drvreg] == FDC_TYPE_2DD) {
			/* fBA^Cv(2DD) != hCu[h(2D) */
			fdctrack = (BYTE)(fdctrack << 1);
		}
#endif
		if (track != fdctrack) {
			return FDC_ST_RECNFND;
		}
		if (side != fdc_sidereg) {
			return FDC_ST_RECNFND;
		}
		if ((sector < 1) || (sector > 16)) {
			return FDC_ST_RECNFND;
		}

		/* f[^|C^ݒ */
		fdc_dataptr = &fdc_buffer[(sector - 1) * 0x0100];
		fdc_secofs[fdc_drvreg] = (sector - 1) * 0x0100;

		/* JE^ݒ */
		fdc_totalcnt = 0x0100;
		fdc_nowcnt = 0;

		return 0;
	}

	/* VFDt@C̏ꍇ */
	if (fdc_ready[fdc_drvreg] == FDC_TYPE_VFD) {
#if XM7_VER >= 3
		if (fdc_2ddmode) {
			/* fBA^Cv(2D) != hCu[h(2DD) */
			if ((fdctrack % 2) == 1) {
				/* 2DC[W2DDANZXAgbNANZX̓G[ */
				return FDC_ST_RECNFND;
			}
			fdctrack = (BYTE)(fdctrack >> 1);
		}
#endif
		if (track != fdctrack) {
			return FDC_ST_RECNFND;
		}
		if (side != fdc_sidereg) {
			return FDC_ST_RECNFND;
		}

		/* gbNւ̃ItZbg`FbN */
		vfdoffset  = fdc_header[fdc_drvreg][track * 6 + 3];
		vfdoffset *= (DWORD)256;
		vfdoffset |= fdc_header[fdc_drvreg][track * 6 + 2];
		vfdoffset *= (DWORD)256;
		vfdoffset |= fdc_header[fdc_drvreg][track * 6 + 1];
		vfdoffset *= (DWORD)256;
		vfdoffset |= fdc_header[fdc_drvreg][track * 6 + 0];
		if (vfdoffset == 0) {
			return FDC_ST_RECNFND;
		}

		/* gbÑZN^`FbN */
		len = fdc_header[fdc_drvreg][track * 6 + 4];
		if (len == 0) {
			len = 128;
		}
		else {
			len *= 256;
		}
		size = fdc_header[fdc_drvreg][track * 6 + 5];
		if ((sector < 1) || (sector > size)) {
			return FDC_ST_RECNFND;
		}

		/* f[^|C^ݒ */
		fdc_dataptr = &fdc_buffer[(sector - 1) * len];
		fdc_secofs[fdc_drvreg] = (sector - 1) * len;

		/* JE^ݒ */
		fdc_totalcnt = (WORD)len;
		fdc_nowcnt = 0;

		return 0;
	}

	/* D77t@C̏ꍇ */
	secs = fdc_buffer[0x0005];
	secs *= (WORD)256;
	secs |= fdc_buffer[0x0004];
	if (secs == 0) {
		return FDC_ST_RECNFND;
	}

#if XM7_VER >= 3
	/* 2DC[W2DDANZXAgbNANZX̓G[ */
	if ((fdc_header[fdc_drvreg][0x001b] == 0x00) && fdc_2ddmode) {
		if ((fdctrack % 2) == 1) {
			return FDC_ST_RECNFND;
		}
	}
#endif

	offset = 0;
	/* ZN^[v */
	for (i=0; i<secs; i++) {
		/* ̃ZN^̃TCYɎ擾 */
		size = fdc_buffer[offset + 0x000f];
		size *= (WORD)256;
		size |= fdc_buffer[offset + 0x000e];

		/* C,H,RvZN^邩 */
		if (fdc_buffer[offset + 0] != track) {
			offset += size;
			offset += (WORD)0x10;
			continue;
		}
		/* TChbit0ȊO͍lȂ悤ɕύX */
		if (sidecmp) {
			if ((BYTE)(fdc_buffer[offset + 1] & 1) != side) {
				offset += size;
				offset += (WORD)0x10;
				continue;
			}
		}
		if (fdc_buffer[offset + 2] != sector) {
			offset += size;
			offset += (WORD)0x10;
			continue;
		}

		/* P`FbN */
		if (fdc_buffer[offset + 0x0006] != 0) {
			continue;
		}

		/* f[^|C^AJE^ݒ */
		fdc_dataptr = &fdc_buffer[offset + 0x0010];
		fdc_secofs[fdc_drvreg] = offset + 0x0010;
		fdc_totalcnt = size;
		fdc_nowcnt = 0;

		/* Xe[^Xݒ */
		stat = 0;
		if (fdc_buffer[offset + 0x0007] != 0) {
			stat |= FDC_ST_RECTYPE;
		}
		if (fdc_buffer[offset + 0x0008] == 0xb0) {
			/* Oɐݒ肵Xe[^XɂȂC (ݼ޼) */
			stat |= FDC_ST_CRCERR;
		}

		return stat;
	}

	/* SZN^AȂ */
	return FDC_ST_RECNFND;
}

/*
 *	gbNǂݍ
 */
static void FASTCALL fdc_readbuf(int drive)
{
	DWORD offset;
	DWORD min_offset;
	DWORD len;
	DWORD secs;
	int trkside;
	int handle;
	int max_track;
	int trk;

	/* hCu`FbN */
	if ((drive < 0) || (drive >= FDC_DRIVES)) {
		return;
	}

	/* fB`FbN */
	if (fdc_ready[drive] == FDC_TYPE_NOTREADY) {
		return;
	}

	/* CfbNXz[JE^NA */
	fdc_indexcnt = 0;

	/* gbN~Q{TCh */
	trkside = fdc_track[drive] * 2 + fdc_sidereg;

	/*
	 * 2D/2DDt@C
	 */
	if ((fdc_ready[fdc_drvreg] == FDC_TYPE_2D) ||
		(fdc_ready[fdc_drvreg] == FDC_TYPE_2DD)) {
		if (fdc_ready[fdc_drvreg] == FDC_TYPE_2D) {
			max_track = 80;

#if XM7_VER >= 3
			/* 2Dt@C2DDǂݏȍꍇ̕␳ */
			if (fdc_2ddmode) {
				trkside = (fdc_track[drive] >> 1) * 2 + fdc_sidereg;
			}
#endif
		}
		else {
			max_track = 160;

#if XM7_VER >= 3
			/* 2DDt@C2Dǂݏȍꍇ̕␳ */
			if (!fdc_2ddmode) {
				trkside = fdc_track[drive] * 4 + fdc_sidereg;
			}
#else
			trkside = fdc_track[drive] * 4 + fdc_sidereg;
#endif
		}

		/* I[o[`FbN */
		if (trkside >= max_track) {
			memset(fdc_buffer, 0, 0x1000);
			return;
		}

		/* ItZbgZo */
		offset = (DWORD)trkside;
		offset *= 0x1000;
		fdc_seekofs[drive] = offset;
		fdc_trklen[drive] = 0x1000;

		/* ǂݍ */
		memset(fdc_buffer, 0, 0x1000);
		handle = file_open(fdc_fname[drive], OPEN_R);
		if (handle == -1) {
			return;
		}
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return;
		}
		file_read(handle, fdc_buffer, 0x1000);
		file_close(handle);
		return;
	}

	/*
	 * VFDt@C
	 */
	if (fdc_ready[drive] == FDC_TYPE_VFD) {
#if XM7_VER >= 3
		/* 2DD[h̏ꍇA␳ */
		if (fdc_2ddmode) {
			trkside = (fdc_track[drive] >> 1) * 2 + fdc_sidereg;
		}
#endif

		/* ͈̓`FbN */
		if (trkside >= 80) {
			memset(fdc_buffer, 0, 0x1000);
			return;
		}

		/* ItZbgZo */
		offset  = fdc_header[drive][trkside * 6 + 3];
		offset *= 256;
		offset |= fdc_header[drive][trkside * 6 + 2];
		offset *= 256;
		offset |= fdc_header[drive][trkside * 6 + 1];
		offset *= 256;
		offset |= fdc_header[drive][trkside * 6 + 0];
		fdc_seekofs[drive] = offset;

		len		= fdc_header[drive][trkside * 6 + 4];
		secs	= fdc_header[drive][trkside * 6 + 5];
		if (len == 0) {
			len = 128;
		}
		else {
			len *= 256;
		}
		fdc_trklen[drive] = (WORD)(len * secs);

		/* ǂݍ */
		memset(fdc_buffer, 0, fdc_trklen[drive]);
		handle = file_open(fdc_fname[drive], OPEN_R);
		if (handle == -1) {
			return;
		}
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return;
		}
		file_read(handle, fdc_buffer, fdc_trklen[drive]);
		file_close(handle);
		return;
	}

	/*
	 * D77t@C
	 */
	if (fdc_header[drive][0x001b] == 0x00) {
		max_track = 84;
	}
	else {
		max_track = 164;
	}

	/* ANZXĂŏIgbN̎Zo */
	min_offset = (0x0020 + max_track * 4);
	for (trk = 0; trk < max_track; trk++) {
		if ((DWORD)(0x0020 + trk * 4) >= min_offset) {
			break;
		}

		offset  = fdc_header[drive][0x0020 + trk * 4 + 3];
		offset *= 256;
		offset |= fdc_header[drive][0x0020 + trk * 4 + 2];
		offset *= 256;
		offset |= fdc_header[drive][0x0020 + trk * 4 + 1];
		offset *= 256;
		offset |= fdc_header[drive][0x0020 + trk * 4 + 0];
		if ((offset < min_offset) && (offset >= 0x20)) {
			min_offset = offset;
		}
	}
	max_track = (min_offset - 0x20) / 4;

#if XM7_VER >= 3
	if (fdc_2ddmode) {
		/* 2Dt@C2DDǂ݂ꍇAŕ␳ */
		if (fdc_header[drive][0x001b] == 0x00) {
			if ((fdc_track[drive] % 2) == 1) {
				/* gbNANZXAZN^0 */
				fdc_buffer[4] = 0;
				fdc_buffer[5] = 0;
				return;
			}
			trkside = (fdc_track[drive] >> 1) * 2 + fdc_sidereg;
		}
	}
	else {
		/* 2DDt@C2Dǂ݂ꍇAŕ␳ (AV40pOS-9) */
		if (fdc_header[drive][0x001b] == 0x10) {
			trkside = fdc_track[drive] * 4 + fdc_sidereg;
		}
	}
#else
	/* 2DDt@C2Dǂ݂ꍇAŕ␳ (AV40pOS-9) */
	if (fdc_header[drive][0x001b] == 0x10) {
		trkside = fdc_track[drive] * 4 + fdc_sidereg;
	}
#endif

	/* I[o[`FbN */
	if (trkside >= max_track) {
		/* gbNI[o[AZN^0 */
		fdc_buffer[4] = 0;
		fdc_buffer[5] = 0;
		return;
	}

	/* wb_ɏ]AItZbgEOXZo */
	offset = *(DWORD *)(&fdc_header[drive][0x0020 + trkside * 4]);
	if (offset == 0) {
		/* ݂ȂgbN */
		fdc_buffer[4] = 0;
		fdc_buffer[5] = 0;
		return;
	}

	len = *(DWORD *)(&fdc_header[drive][0x0020 + (trkside + 1) * 4]);
	if ((len == 0) || ((trkside + 1) >= max_track)) {
		/* ŏIgbN */
		len = *(DWORD *)(&fdc_header[drive][0x0014]);
	}
	len -= offset;
	if (len > 0x2000) {
		len = 0x2000;
	}
	fdc_seekofs[drive] = offset;
	fdc_trklen[drive] = (WORD)len;

	/* V[NAǂݍ */
	memset(fdc_buffer, 0, 0x2000);
	handle = file_open(fdc_fname[drive], OPEN_R);
	if (handle == -1) {
		return;
	}
	if (!file_seek(handle, offset)) {
		file_close(handle);
		return;
	}
	file_read(handle, fdc_buffer, len);
	file_close(handle);
}

/*
 *	D77t@C wb_ǂݍ
 */
static BOOL FASTCALL fdc_readhead(int drive, int index)
{
	int i;
	DWORD offset;
	DWORD temp;
	int handle;

	/* assert */
	ASSERT((drive >= 0) && (drive < FDC_DRIVES));
	ASSERT((index >= 0) && (index < FDC_MEDIAS));
	ASSERT(fdc_ready[drive] == FDC_TYPE_D77);

	/* ItZbg */
	offset = fdc_foffset[drive][index];

	/* V[NAǂݍ */
	handle = file_open(fdc_fname[drive], OPEN_R);
	if (handle == -1) {
		return FALSE;
	}
	if (!file_seek(handle, offset)) {
		file_close(handle);
		return FALSE;
	}
	if (!file_read(handle, fdc_header[drive], 0x2b0)) {
		file_close(handle);
		return FALSE;
	}
	file_close(handle);

	/* ^Cv`FbNACgveNgݒ */
	if ((fdc_header[drive][0x001b] != 0x00) &&
		(fdc_header[drive][0x001b] != 0x10)) {
		/* 2D/2DDłȂ */
		return FALSE;
	}
	if (fdc_fwritep[drive]) {
		fdc_writep[drive] = TRUE;
	}
	else {
		if (fdc_header[drive][0x001a] & 0x10) {
			fdc_writep[drive] = TRUE;
		}
		else {
			fdc_writep[drive] = FALSE;
		}
	}

	/* gbNItZbgݒ */
	for (i=0; i<164; i++) {
		temp = 0;
		temp |= fdc_header[drive][0x0020 + i * 4 + 3];
		temp *= 256;
		temp |= fdc_header[drive][0x0020 + i * 4 + 2];
		temp *= 256;
		temp |= fdc_header[drive][0x0020 + i * 4 + 1];
		temp *= 256;
		temp |= fdc_header[drive][0x0020 + i * 4 + 0];

		if (temp != 0) {
			/* f[^ */
			temp += offset;
			*(DWORD *)(&fdc_header[drive][0x0020 + i * 4]) = temp;
		}
	}

	/* fBXNTCY{ItZbg */
	temp = 0;
	temp |= fdc_header[drive][0x001c + 3];
	temp *= 256;
	temp |= fdc_header[drive][0x001c + 2];
	temp *= 256;
	temp |= fdc_header[drive][0x001c + 1];
	temp *= 256;
	temp |= fdc_header[drive][0x001c + 0];
	temp += offset;
	*(DWORD *)(&fdc_header[drive][0x0014]) = temp;

	return TRUE;
}

/*
 *	VFDt@C wb_ǂݍ
 */
static BOOL FASTCALL fdc_readhead_vfd(int drive)
{
	int handle;

	/* assert */
	ASSERT((drive >= 0) && (drive < FDC_DRIVES));
	ASSERT(fdc_ready[drive] == FDC_TYPE_VFD);

	/* V[NAǂݍ */
	handle = file_open(fdc_fname[drive], OPEN_R);
	if (handle == -1) {
		return FALSE;
	}
	if (!file_seek(handle, 0)) {
		file_close(handle);
		return FALSE;
	}
	if (!file_read(handle, fdc_header[drive], 0x1e0)) {
		file_close(handle);
		return FALSE;
	}
	file_close(handle);

	return TRUE;
}

/*
 *	݂̃fBÃCgveNg؂ւ
 */
BOOL FASTCALL fdc_setwritep(int drive, BOOL writep)
{
	BYTE header[0x2b0];
	DWORD offset;
	int handle;

	/* assert */
	ASSERT((drive >= 0) && (drive < FDC_DRIVES));
	ASSERT((writep == TRUE) || (writep == FALSE));

	/* fBłȂ΂ȂȂ */
	if (fdc_ready[drive] == FDC_TYPE_NOTREADY) {
		return FALSE;
	}

	/* t@CݕsȂ_ */
	if (fdc_fwritep[drive]) {
		return FALSE;
	}

	/* ǂݍ݁AݒA */
	if (fdc_ready[drive] == FDC_TYPE_D77) {
		offset = fdc_foffset[drive][fdc_media[drive]];
		handle = file_open(fdc_fname[drive], OPEN_RW);
		if (handle == -1) {
			return FALSE;
		}
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return FALSE;
		}
		if (!file_read(handle, header, 0x2b0)) {
			file_close(handle);
			return FALSE;
		}
		if (writep) {
			header[0x1a] |= 0x10;
		}
		else {
			header[0x1a] &= ~0x10;
		}
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return FALSE;
		}
		if (!file_write(handle, header, 0x2b0)) {
			file_close(handle);
			return FALSE;
		}
	}

	/*  */
	file_close(handle);
	fdc_writep[drive] = writep;
	return TRUE;
}

/*
 *	fBAԍݒ
 */
BOOL FASTCALL fdc_setmedia(int drive, int index)
{
	/* assert */
	ASSERT((drive >= 0) && (drive < FDC_DRIVES));
	ASSERT((index >= 0) && (index < FDC_MEDIAS));

	/* fBԂ */
	if (fdc_ready[drive] == FDC_TYPE_NOTREADY) {
		return FALSE;
	}

	/* 2D/2DDt@C̏ꍇAindex = 0 */
	if (((fdc_ready[drive] == FDC_TYPE_2D) ||
		 (fdc_ready[drive] == FDC_TYPE_2DD)) && (index != 0)) {
		return FALSE;
	}

	/* VFDt@C̏ꍇAindex = 0`FbNăwb_ǂݍ */
	if (fdc_ready[drive] == FDC_TYPE_VFD) {
		if (index != 0) {
			return FALSE;
		}
		if (!fdc_readhead_vfd(drive)) {
			return FALSE;
		}
	}

	/* index > 0 ȂAfdc_foffset𒲂ׂ>0Kv */
	if (index > 0) {
		if (fdc_foffset[drive][index] == 0) {
			return FALSE;
		}
	}

	/* D77t@C̏ꍇAwb_ǂݍ */
	if (fdc_ready[drive] == FDC_TYPE_D77) {
		/* CgveNg͓Őݒ */
		if (!fdc_readhead(drive, index)) {
			return FALSE;
		}
	}
	else {
		/* 2D/2DD/VFDt@CȂAt@Cɏ] */
		fdc_writep[drive] = fdc_fwritep[drive];
	}

	/* fBAꂽꍇAꎞCWFNg */
	if (fdc_media[drive] != index) {
		fdc_teject[drive] = FALSE;
	}

	/* f[^obt@ǂݍ݁A[NZ[u */
	fdc_media[drive] = (BYTE)index;
	if (drive == fdc_drvreg) {
		/* JghCuƈvꍇ̂݃obt@ǂݍ݂s */
		fdc_readbuf(drive);
	}

	return TRUE;
}

/*
 *	D77t@ĆAfBAі̎擾
 */
static int FASTCALL fdc_chkd77(int drive)
{
	int i;
	int handle;
	int count;
	int max_track;
	int trk;
	DWORD offset;
	DWORD len;
	DWORD trkoffset;
	DWORD min_offset;
	BYTE buf[0x2b0];

	/*  */
	for (i=0; i<FDC_MEDIAS; i++) {
		fdc_foffset[drive][i] = 0;
		fdc_name[drive][i][0] = '\0';
	}
	count = 0;
	offset = 0;

	/* t@CI[v */
	handle = file_open(fdc_fname[drive], OPEN_R);
	if (handle == -1) {
		return count;
	}

	/* fBA[v */
	while (count < FDC_MEDIAS) {
		/* V[N */
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return count;
		}

		/* ǂݍ */
		if (!file_read(handle, buf, 0x02b0)) {
			file_close(handle);
			return count;
		}

		/* ^Cv`FbNB2D,2DD̂ݑΉ */
		if ((buf[0x1b] != 0) && (buf[0x1b] != 0x10)) {
			file_close(handle);
			return count;
		}
		if (buf[0x1b] == 0x00) {
			max_track = 84;
		}
		else {
			max_track = 164;
		}

		/* ANZXĂŏIgbN̎Zo */
		min_offset = (0x0020 + max_track * 4);
		for (trk = 0; trk < max_track; trk++) {
			if ((DWORD)(0x0020 + trk * 4) >= min_offset) {
				break;
			}

			trkoffset = buf[0x20 + trk * 4 + 3];
			trkoffset *= 256;
			trkoffset |= buf[0x20 + trk * 4 + 2];
			trkoffset *= 256;
			trkoffset |= buf[0x20 + trk * 4 + 1];
			trkoffset *= 256;
			trkoffset |= buf[0x20 + trk * 4 + 0];
			if ((trkoffset < min_offset) && (trkoffset >= 0x20)) {
				min_offset = trkoffset;
			}
		}
		max_track = (min_offset - 0x20) / 4;

		/* ok,t@CAItZbgi[ */
		buf[16] = '\0';
		memcpy(fdc_name[drive][count], buf, 17);
		fdc_foffset[drive][count] = offset;

		/* next */
		len = 0;
		len |= buf[0x1f];
		len *= 256;
		len |= buf[0x1e];
		len *= 256;
		len |= buf[0x1d];
		len *= 256;
		len |= buf[0x1c];
		if (len == 0){
			file_close(handle);
			return count;
		}
		for (trk = 0; trk < max_track; trk++) {
			trkoffset = buf[0x20 + trk * 4 + 3];
			trkoffset *= 256;
			trkoffset |= buf[0x20 + trk * 4 + 2];
			trkoffset *= 256;
			trkoffset |= buf[0x20 + trk * 4 + 1];
			trkoffset *= 256;
			trkoffset |= buf[0x20 + trk * 4 + 0];
			if (trkoffset >= len) {
				file_close(handle);
				return count;
			}
		}
		offset += len;
		count++;
	}

	/* ő僁fBAɒB */
	file_close(handle);
	return count;
}

/*
 *	VFDt@C`FbN
 */
static int FASTCALL fdc_chkvfd(int drive)
{
	int	i;
	int handle;
	BYTE buf[0x20];

	/*  */
	for (i=0; i<FDC_MEDIAS; i++) {
		fdc_foffset[drive][i] = 0;
		fdc_name[drive][i][0] = '\0';
	}

	/* t@CI[v */
	handle = file_open(fdc_fname[drive], OPEN_R);
	if (handle == -1) {
		return 0;
	}

	/* wb_̃`FbN */
	if (!file_seek(handle, 0)) {
		file_close(handle);
		return 0;
	}
	if (!file_read(handle, buf, 0x0020)) {
		file_close(handle);
		return 0;
	}
	file_close(handle);

	if (	(buf[0x00] != 0xe0) || (buf[0x01] != 0x01) ||
			(buf[0x02] != 0x00) || (buf[0x03] != 0x00)) {
		/* gbN0̃ItZbg0x01e0ȊOȂVFDł͂Ȃ(蔲c) */
		return 0;
	}

	return 1;
}

/*
 *	fBXNt@Cݒ
 */
int FASTCALL fdc_setdisk(int drive, char *fname)
{
	BOOL writep;
	int handle;
	DWORD fsize;
	int count;
	BOOL flag;
	int i;

	ASSERT((drive >= 0) && (drive < FDC_DRIVES));

	/* mbgfBɂꍇ */
	if (fname == NULL) {
		fdc_ready[drive] = FDC_TYPE_NOTREADY;
		fdc_fname[drive][0] = '\0';
		return 1;
	}

	/* t@CI[vAt@CTCY𒲂ׂ */
	if (strlen(fname) < sizeof(fdc_fname[drive])) {
		strcpy(fdc_fname[drive], fname);
	}
	else {
		fdc_ready[drive] = FDC_TYPE_NOTREADY;
		fdc_fname[drive][0] = '\0';
		return 1;
	}
	writep = FALSE;
	handle = file_open(fdc_fname[drive], OPEN_RW);
	if (handle == -1) {
		handle = file_open(fdc_fname[drive], OPEN_R);
		if (handle == -1) {
			return 0;
		}
		writep = TRUE;
	}
	fsize = file_getsize(handle);
	file_close(handle);

	/*
	 * 2Dt@C
	 */
	if (fsize == 327680) {
		/* ^CvAݑݒ */
		fdc_ready[drive] = FDC_TYPE_2D;
		fdc_fwritep[drive] = writep;

		/* fBAݒ */
		if (!fdc_setmedia(drive, 0)) {
			fdc_ready[drive] = FDC_TYPE_NOTREADY;
			return 0;
		}

		/* BꎞCWFNg */
		fdc_teject[drive] = FALSE;
		fdc_medias[drive] = 1;
		return 1;
	}

	/*
	 * 2DDt@C
	 */
	if (fsize == 655360) {
		/* ^CvAݑݒ */
		fdc_ready[drive] = FDC_TYPE_2DD;
		fdc_fwritep[drive] = writep;

		/* fBAݒ */
		if (!fdc_setmedia(drive, 0)) {
			fdc_ready[drive] = FDC_TYPE_NOTREADY;
			return 0;
		}

		/* BꎞCWFNg */
		fdc_teject[drive] = FALSE;
		fdc_medias[drive] = 1;
		return 1;
	}

	/*
	 * VFDt@C
	 */
	/* t@C */
	if (fdc_chkvfd(drive) != 0) {
		fdc_ready[drive] = FDC_TYPE_VFD;
		fdc_fwritep[drive] = writep;

		/* fBAݒ */
		if (!fdc_setmedia(drive, 0)) {
			fdc_ready[drive] = FDC_TYPE_NOTREADY;
			return 0;
		}

		/* BꎞCWFNg */
		fdc_teject[drive] = FALSE;
		fdc_medias[drive] = 1;
		return 1;
	}

	/*
	 * D77t@C
	 */
	fdc_ready[drive] = FDC_TYPE_D77;
	fdc_fwritep[drive] = writep;

	/* t@C */
	count = fdc_chkd77(drive);
	if (count == 0){
		fdc_ready[drive] = FDC_TYPE_NOTREADY;
		return 0;
	}

	/* fBAݒ */
	flag = FALSE;
	for (i = 0; i < 16; i++) {
		if (fdc_setmedia(drive, i)) {
			flag = TRUE;
			break;
		}
	}
	if (!flag) {
		fdc_ready[drive] = FDC_TYPE_NOTREADY;
		return 0;
	}

	/* BꎞCWFNg */
	fdc_teject[drive] = FALSE;
	fdc_medias[drive] = (BYTE)count;
	return count;
}

/*-[ FDCR}h EFCg[h ]---------------------------------------*/

/*
 *	FDC DataRequestCxg (WAIT)
 */
#ifdef FDDSND
static BOOL FASTCALL fdc_drq_event(void)
{
	/* Xgf[^`FbN */
	if (fdc_drqirq & 0x80) {
		return fdc_lost_event();
	}

	fdc_status |= FDC_ST_DRQ;
	fdc_drqirq |= 0x80;

	return TRUE;
}

/*
 *	FDC V[NCxg (WAIT)
 */
static BOOL FASTCALL fdd_seek_event(void)
{
	/* V[NI */
	if (fdc_seek_track < 0) {
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;

		/* BUSYtO𗎂Ƃ */
		fdc_status &= ~FDC_ST_BUSY;
		fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
		schedule_delevent(EVENT_FDD_SEEK);
	}
	else if (fdc_seek_track-- == 0) {
		/* V[NI̓EFCg} */
		schedule_setevent(EVENT_FDD_SEEK, 20000, fdd_seek_event);
	}
	else {
		/* TEh */
		if (fdc_sound) {
			wav_notify(SOUND_FDDSEEK);
		}
	}

	return TRUE;
}

/*
 *	FDC V[NCxgݒ (SOUND ON)
 */
static void FASTCALL fdc_setseekevent(BYTE track)
{
	/* V[NgbNۑ */
	fdc_seek_track = track;

	/* Cxgݒ */
	if (track > 0) {
		schedule_setevent(EVENT_FDD_SEEK, fdc_steprate[fdc_command & 3], fdd_seek_event);
	}
	else {
		/* wbhړȂĂ΂炭̊ԂBUSYԂɂ */
		schedule_setevent(EVENT_FDD_SEEK, 300, fdd_seek_event);
	}
}
#endif

/*-[ FDCR}h ]----------------------------------------------------------*/

/*
 *	FDC Xe[^X쐬
 */
static void FASTCALL fdc_make_stat(void)
{
	/* hCu`FbN */
	if (fdc_drvreg >= FDC_DRIVES) {
		fdc_status |= FDC_ST_NOTREADY;
		return;
	}

	/* LȃhCu */
	if (fdc_ready[fdc_drvreg] == FDC_TYPE_NOTREADY) {
		fdc_status |= FDC_ST_NOTREADY;
	}
	else {
		fdc_status &= (BYTE)(~FDC_ST_NOTREADY);
	}

	/* ꎞCWFNg */
	if (fdc_teject[fdc_drvreg]) {
		fdc_status |= FDC_ST_NOTREADY;
	}

	/* CgveNg(ReadnR}h0) */
	if ((fdc_cmdtype == 2) || (fdc_cmdtype == 4) || (fdc_cmdtype == 6)) {
		fdc_status &= ~FDC_ST_WRITEP;
	}
	else {
		if (fdc_writep[fdc_drvreg] || (fdc_status & FDC_ST_NOTREADY)) {
			fdc_status |= FDC_ST_WRITEP;
		}
		else {
			fdc_status &= ~FDC_ST_WRITEP;
		}
	}

	/* TYPE I ̂ */
	if (fdc_cmdtype != 1) {
		return;
	}

	/* TRACK00 */
	if (fdc_track[fdc_drvreg] == 0) {
		fdc_status |= FDC_ST_TRACK00;
	}
	else {
		fdc_status &= ~FDC_ST_TRACK00;
	}

	/* index */
	if (!(fdc_status & FDC_ST_NOTREADY)) {
		if (fdc_indexcnt == 0) {
			fdc_status |= FDC_ST_INDEX;
		}
		else {
			fdc_status &= ~FDC_ST_INDEX;
		}
		fdc_next_index();
	}
}

/*
 *	TYPE I
 *	RESTORE
 */
static void FASTCALL fdc_restore(void)
{
#ifdef FDDSND
	BYTE prevtrk;
#endif

	/* TYPE I */
	fdc_cmdtype = 1;
	fdc_status = 0;

	/* hCu`FbN */
	if (fdc_drvreg >= FDC_DRIVES) {
		mainetc_fdc();
		fdc_drqirq = 0x40;
		fdc_make_stat();
		return;
	}

#ifdef FDDSND
	/* ݂̃gbNԍۑ */
	prevtrk = fdc_track[fdc_drvreg];
#endif

	/* gbNrAXgAAǂݍ */
	if (fdc_track[fdc_drvreg] != 0) {
		fdc_track[fdc_drvreg] = 0;
		fdc_readbuf(fdc_drvreg);
	}
	fdc_seekvct = TRUE;

	/* Abvf[g(f[^WX^0ɂ) */
	fdc_trkreg = 0;
	fdc_datareg = 0;

	/* FDC荞 */
	fdc_drqirq = 0x00;
#ifdef FDDSND
	if (fdc_wait) {
		fdc_setseekevent(prevtrk);
	}
	else {
		if (!mfd_irq_mask) {
			mainetc_fdc();
			fdc_drqirq |= (BYTE)0x40;
		}
	}
#else
	if (!mfd_irq_mask) {
		mainetc_fdc();
		fdc_drqirq |= (BYTE)0x40;
	}
#endif

	/* Xe[^X */
	fdc_status = FDC_ST_BUSY;
	if (fdc_command & 0x08) {
		fdc_status |= FDC_ST_HEADENG;
	}
	fdc_make_stat();

	/* ANZX(SEEK) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_SEEK;
}

/*
 *	TYPE I
 *	SEEK
 */
static void FASTCALL fdc_seek(void)
{
	BYTE target;
#ifdef FDDSND
	BYTE prevtrk;
#endif

	/* TYPE I */
	fdc_cmdtype = 1;
	fdc_status = 0;

	/* hCu`FbN */
	if (fdc_drvreg >= FDC_DRIVES) {
		mainetc_fdc();
		fdc_drqirq = 0x40;
		fdc_make_stat();
		return;
	}

	/* Ƀxt@C */
	if (fdc_command & 0x04) {
		if (fdc_trkreg != fdc_track[fdc_drvreg]) {
			fdc_status |= FDC_ST_SEEKERR;
			/* C(ՂĂ΍) */
			fdc_trkreg = fdc_track[fdc_drvreg];
		}
	}

#ifdef FDDSND
	/* ݂̃gbNԍۑ */
	prevtrk = fdc_track[fdc_drvreg];
#endif

	/* ΃V[N */
	target = (BYTE)(fdc_track[fdc_drvreg] + fdc_datareg - fdc_trkreg);
	if (fdc_datareg > fdc_trkreg) {
		fdc_seekvct = FALSE;
#if XM7_VER >= 3
		if (fdc_2ddmode) {
			if (target > 81) {
				target = 81;
			}
		}
		else {
			if (target > 41) {
				target = 41;
			}
		}
#else
		if (target > 41) {
			target = 41;
		}
#endif
	}
	else {
		fdc_seekvct = TRUE;
		/* gbNԍ̃I[o[t[h~ (OS-9΍) */
		if (fdc_track[fdc_drvreg] < (fdc_trkreg - fdc_datareg)) {
			target = 0;
		}
	}

	/* gbNrAV[NAǂݍ */
	if (fdc_track[fdc_drvreg] != target) {
		fdc_track[fdc_drvreg] = target;
		fdc_readbuf(fdc_drvreg);
	}

	/* Abvf[g */
	fdc_trkreg = fdc_datareg;	/* f[^WX^̒lf͗l */

	/* FDC荞 */
	fdc_drqirq = 0x00;
#ifdef FDDSND
	if (fdc_wait) {
		fdc_setseekevent((BYTE)abs(target - prevtrk));
	}
	else {
		if (!mfd_irq_mask) {
			mainetc_fdc();
			fdc_drqirq |= (BYTE)0x40;
		}
	}
#else
	if (!mfd_irq_mask) {
		mainetc_fdc();
		fdc_drqirq |= (BYTE)0x40;
	}
#endif

	/* Xe[^X */
	fdc_status |= FDC_ST_BUSY;
	if (fdc_command & 0x08) {
		fdc_status |= FDC_ST_HEADENG;
	}
	fdc_make_stat();

	/* ANZX(SEEK) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_SEEK;
}

/*
 *	TYPE I
 *	STEP IN
 */
static void FASTCALL fdc_step_in(void)
{
#ifdef FDDSND
	BYTE prevtrk;
#endif

	/* TYPE I */
	fdc_cmdtype = 1;
	fdc_status = 0;

	/* hCu`FbN */
	if (fdc_drvreg >= FDC_DRIVES) {
		mainetc_fdc();
		fdc_drqirq = 0x40;
		fdc_make_stat();
		return;
	}

#ifdef FDDSND
	/* ݂̃gbNԍۑ */
	prevtrk = fdc_track[fdc_drvreg];
#endif

	/* Ƀxt@C */
	if (fdc_command & 0x04) {
		if (fdc_trkreg != fdc_track[fdc_drvreg]) {
			fdc_status |= FDC_ST_SEEKERR;
		}
	}

	/* XebvAǂݍ */
#if XM7_VER >= 3
	if (fdc_2ddmode) {
		if (fdc_track[fdc_drvreg] < 81) {
			fdc_track[fdc_drvreg]++;
			fdc_readbuf(fdc_drvreg);
		}
	}
	else {
		if (fdc_track[fdc_drvreg] < 41) {
			fdc_track[fdc_drvreg]++;
			fdc_readbuf(fdc_drvreg);
		}
	}
#else
	if (fdc_track[fdc_drvreg] < 41) {
		fdc_track[fdc_drvreg]++;
		fdc_readbuf(fdc_drvreg);
	}
#endif
	fdc_seekvct = FALSE;

	/* Abvf[g */
	if (fdc_command & 0x10) {
		if (fdc_trkreg < 255) {
			fdc_trkreg++;	/* gbNWX^̂̍XV݂̂Ǝv */
		}
	}

	/* FDC荞 */
	fdc_drqirq = 0x00;
#ifdef FDDSND
	if (fdc_wait && (prevtrk != fdc_track[fdc_drvreg])) {
		fdc_setseekevent(1);
	}
	else {
		if (!mfd_irq_mask) {
			mainetc_fdc();
			fdc_drqirq |= (BYTE)0x40;
		}
	}
#else
	if (!mfd_irq_mask) {
		mainetc_fdc();
		fdc_drqirq |= (BYTE)0x40;
	}
#endif

	/* Xe[^X */
	fdc_status |= FDC_ST_BUSY;
	if (fdc_command & 0x08) {
		fdc_status |= FDC_ST_HEADENG;
	}
	fdc_make_stat();

	/* ANZX(SEEK) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_SEEK;
}

/*
 *	TYPE I
 *	STEP OUT
 */
static void FASTCALL fdc_step_out(void)
{
#ifdef FDDSND
	BYTE prevtrk;
#endif

	/* TYPE I */
	fdc_cmdtype = 1;
	fdc_status = 0;

	/* hCu`FbN */
	if (fdc_drvreg >= FDC_DRIVES) {
		mainetc_fdc();
		fdc_drqirq = 0x40;
		fdc_make_stat();
		return;
	}

#ifdef FDDSND
	/* ݂̃gbNԍۑ */
	prevtrk = fdc_track[fdc_drvreg];
#endif

	/* Ƀxt@C */
	if (fdc_command & 0x04) {
		if (fdc_trkreg != fdc_track[fdc_drvreg]) {
			fdc_status |= FDC_ST_SEEKERR;
		}
	}

	/* XebvAǂݍ */
	if (fdc_track[fdc_drvreg] != 0) {
		fdc_track[fdc_drvreg]--;
		fdc_readbuf(fdc_drvreg);
	}
	fdc_seekvct = TRUE;

	/* Abvf[g */
	if (fdc_command & 0x10) {
		if (fdc_trkreg > 0) {
			fdc_trkreg--;	/* gbNWX^̂̍XV݂̂Ǝv */
		}
	}

	/* FDC荞 */
	fdc_drqirq = 0x00;
#ifdef FDDSND
	if (fdc_wait && (prevtrk != fdc_track[fdc_drvreg])) {
		fdc_setseekevent(1);
	}
	else {
		if (!mfd_irq_mask) {
			mainetc_fdc();
			fdc_drqirq |= (BYTE)0x40;
		}
	}
#else
	if (!mfd_irq_mask) {
		mainetc_fdc();
		fdc_drqirq |= (BYTE)0x40;
	}
#endif

	/* Xe[^X */
	fdc_status |= FDC_ST_BUSY;
	if (fdc_command & 0x08) {
		fdc_status |= FDC_ST_HEADENG;
	}
	fdc_make_stat();

	/* ANZX(SEEK) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_SEEK;
}

/*
 *	TYPE I
 *	STEP
 */
static void FASTCALL fdc_step(void)
{
	if (fdc_seekvct) {
		fdc_step_out();
	}
	else {
		fdc_step_in();
	}
}

/*
 *	TYPE II, III
 *	READ/WRITE Tu
 */
static BOOL FASTCALL fdc_rw_sub(void)
{
	fdc_status = 0;

	/* hCu`FbN */
	if (fdc_drvreg >= FDC_DRIVES) {
		fdc_make_stat();
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;
		return FALSE;
	}

	/* NOT READY`FbN */
	if ((fdc_ready[fdc_drvreg] == FDC_TYPE_NOTREADY) || fdc_teject[fdc_drvreg]) {
		fdc_make_stat();
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;
		return FALSE;
	}

	return TRUE;
}

/*
 *	TYPE II
 *	READ DATA
 */
static void FASTCALL fdc_read_data(void)
{
	BYTE stat;

	/* TYPE II, Read */
	fdc_cmdtype = 2;

	/* {`FbN */
	if (!fdc_rw_sub()) {
		return;
	}

	/* ZN^ */
	if (fdc_command & 0x02) {
		stat = fdc_readsec(fdc_trkreg, fdc_secreg, (BYTE)((fdc_command & 0x08) >> 3), TRUE);
	}
	else {
		stat = fdc_readsec(fdc_trkreg, fdc_secreg, fdc_sidereg, FALSE);
	}

	/* ɃXe[^Xݒ肷 */
	fdc_status = stat;

	/* RECORD NOT FOUND ? */
	if (fdc_status & FDC_ST_RECNFND) {
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;
		fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
		return;
	}

	/* ŏ̃f[^ݒ */
	fdc_status |= FDC_ST_BUSY;
	fdc_datareg = fdc_dataptr[0];
#ifdef FDDSND
	if (fdc_wait) {
		schedule_setevent(EVENT_FDC_L, FDC_LOST_TIME * 48, fdc_drq_event);
		fdc_drqirq = 0x00;
	}
	else {
		fdc_status |= FDC_ST_DRQ;
		fdc_drqirq = 0x80;
	}
#else
	fdc_status |= FDC_ST_DRQ;
	fdc_drqirq = 0x80;
#endif

	/* ANZX(READ) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_READ;

	/* DMA]JnAXgf[^Cxgݒ */
#if XM7_VER >= 3
	dmac_start();
#endif
#ifdef FDDSND
	if (!fdc_wait) {
		schedule_setevent(EVENT_FDC_L, 30 * 1000, fdc_lost_event);
	}
#else
	schedule_setevent(EVENT_FDC_L, 30 * 1000, fdc_lost_event);
#endif
}

/*
 *	TYPE II
 *	WRITE DATA
 */
static void FASTCALL fdc_write_data(void)
{
	BYTE stat;

	/* TYPE II, Write */
	fdc_cmdtype = 3;

	/* {`FbN */
	if (!fdc_rw_sub()) {
		return;
	}

	/* WRITE PROTECT`FbN */
	if (fdc_writep[fdc_drvreg] != 0) {
		fdc_make_stat();
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;
		return;
	}

	/* ZN^ */
	if (fdc_command & 0x02) {
		stat = fdc_readsec(fdc_trkreg, fdc_secreg, (BYTE)((fdc_command & 0x08) >> 3), TRUE);
	}
	else {
		stat = fdc_readsec(fdc_trkreg, fdc_secreg, fdc_sidereg, FALSE);
	}

	/* ɃXe[^Xݒ肷 */
	fdc_status = stat;

	/* RECORD NOT FOUND ? */
	if (fdc_status & FDC_ST_RECNFND) {
		fdc_status = FDC_ST_RECNFND;
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;
		fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
		return;
	}

	/* DRQ */
#ifdef FDDSND
	fdc_status = FDC_ST_BUSY;
	if (fdc_wait) {
		schedule_setevent(EVENT_FDC_L, FDC_LOST_TIME * 48, fdc_drq_event);
		fdc_drqirq = 0x00;
	}
	else {
		fdc_status |= FDC_ST_DRQ;
		fdc_drqirq = 0x80;
	}
#else
	fdc_status = FDC_ST_BUSY | FDC_ST_DRQ;
	fdc_drqirq = 0x80;
#endif

	/* ANZX(WRITE) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_WRITE;

	/* DMA]JnAXgf[^Cxgݒ */
#if XM7_VER >= 3
	dmac_start();
#endif
#ifdef FDDSND
	if (!fdc_wait) {
		schedule_setevent(EVENT_FDC_L, 30 * 1000, fdc_lost_event);
	}
#else
	schedule_setevent(EVENT_FDC_L, 30 * 1000, fdc_lost_event);
#endif
}

/*
 *	TYPE III
 *	READ ADDRESS
 */
static void FASTCALL fdc_read_addr(void)
{
	int idx;

	/* TYPE III, Read Address */
	fdc_cmdtype = 4;

	/* {`FbN */
	if (!fdc_rw_sub()) {
		return;
	}

	/* gbN擪̑΃ZN^ԍ擾 */
	idx = fdc_next_index();

	/* AtH[}bg`FbN */
	if (idx == -1) {
		fdc_status = FDC_ST_RECNFND;
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;
		return;
	}

	/* f[^쐬 */
	fdc_makeaddr(idx);

	/* ŏ̃f[^ݒ */
	fdc_status |= FDC_ST_BUSY;
	fdc_datareg = fdc_dataptr[0];
#ifdef FDDSND
	if (fdc_wait) {
		schedule_setevent(EVENT_FDC_L, FDC_LOST_TIME * 4, fdc_drq_event);
		fdc_drqirq = 0x00;
	}
	else {
		fdc_status |= FDC_ST_DRQ;
		fdc_drqirq = 0x80;
	}
#else
	fdc_status |= FDC_ST_DRQ;
	fdc_drqirq = 0x80;
#endif

	/* ANZX(READ) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_READ;

	/* DMA]JnAXgf[^Cxgݒ */
#if XM7_VER >= 3
	dmac_start();
#endif
#ifdef FDDSND
	if (!fdc_wait) {
		schedule_setevent(EVENT_FDC_L, 10 * 1000, fdc_lost_event);
	}
#else
	schedule_setevent(EVENT_FDC_L, 10 * 1000, fdc_lost_event);
#endif
}

/*
 *	TYPE III
 *	READ TRACK
 */
static void FASTCALL fdc_read_track(void)
{
	/* TYPE III, Read Track */
	fdc_cmdtype = 6;

	/* {`FbN */
	if (!fdc_rw_sub()) {
		return;
	}

	/* f[^쐬 */
	fdc_make_track();

	/* ŏ̃f[^ݒ */
	fdc_status |= FDC_ST_BUSY;
	fdc_datareg = fdc_dataptr[0];
#ifdef FDDSND
	if (fdc_wait) {
		schedule_setevent(EVENT_FDC_L, FDC_LOST_TIME, fdc_drq_event);
		fdc_drqirq = 0x00;
	}
	else {
		fdc_status |= FDC_ST_DRQ;
		fdc_drqirq = 0x80;
	}
#else
	fdc_status |= FDC_ST_DRQ;
	fdc_drqirq = 0x80;
#endif

	/* ANZX(READ) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_READ;

	/* DMA]JnAXgf[^Cxgݒ */
#if XM7_VER >= 3
	dmac_start();
#endif
#ifdef FDDSND
	if (!fdc_wait) {
		schedule_setevent(EVENT_FDC_L, 150 * 1000, fdc_lost_event);
	}
#else
	schedule_setevent(EVENT_FDC_L, 150 * 1000, fdc_lost_event);
#endif
}

/*
 *	TYPE III
 *	WRITE TRACK
 */
static void FASTCALL fdc_write_track(void)
{
	fdc_status = 0;

	/* TYPE III, Write */
	fdc_cmdtype = 5;

	/* {`FbN */
	if (!fdc_rw_sub()) {
		return;
	}

	/* WRITE PROTECT`FbN */
	if (fdc_writep[fdc_drvreg] != 0) {
		fdc_make_stat();
		/* FDC荞 */
		mainetc_fdc();
		fdc_drqirq = 0x40;
		return;
	}

	/* DRQ */
#ifdef FDDSND
	fdc_status = FDC_ST_BUSY;
	if (fdc_wait) {
		schedule_setevent(EVENT_FDC_L, FDC_LOST_TIME, fdc_drq_event);
		fdc_drqirq = 0x00;
	}
	else {
		fdc_status |= FDC_ST_DRQ;
		fdc_drqirq = 0x80;
	}
#else
	fdc_status = FDC_ST_BUSY | FDC_ST_DRQ;
	fdc_drqirq = 0x80;
#endif

	fdc_dataptr = fdc_buffer;
	fdc_totalcnt = 0x1800;
	fdc_nowcnt = 0;

	/* ANZX(WRITE) */
	fdc_access[fdc_drvreg] = FDC_ACCESS_WRITE;

	/* DMA]JnAXgf[^Cxgݒ */
#if XM7_VER >= 3
	dmac_start();
#endif
#ifdef FDDSND
	if (!fdc_wait) {
		schedule_setevent(EVENT_FDC_L, 150 * 1000, fdc_lost_event);
	}
#else
	schedule_setevent(EVENT_FDC_L, 150 * 1000, fdc_lost_event);
#endif
}

/*
 *	TYPE IV
 *	FORCE INTERRUPT
 */
static void FASTCALL fdc_force_intr(void)
{
	/* WRITE TRACKI */
	if (fdc_cmdtype == 5) {
		if (!fdc_writetrk()) {
			fdc_status |= FDC_ST_WRITEFAULT;
		}
		/* tH[}bĝߎgpobt@C */
		fdc_readbuf(fdc_drvreg);
	}

	/* ANZX~ */
#ifdef FDDSND
	if (!fdc_wait) {
		schedule_delevent(EVENT_FDC_L);
	}
#endif
	fdc_readbuf(fdc_drvreg);
	fdc_dataptr = NULL;

	/* Xe[^X */
	switch (fdc_access[fdc_drvreg]) {
		case FDC_ACCESS_READ:
		case FDC_ACCESS_WRITE:
			/* s̃R}hƓXe[^X */
			fdc_status &= ~FDC_ST_BUSY;
			break;

		case FDC_ACCESS_SEEK:
		case FDC_ACCESS_READY:
			fdc_status = 0;
			fdc_indexcnt = 0;
			fdc_make_stat();
			break;
	}

	/* ŃANZXREADY */
	fdc_access[fdc_drvreg] = FDC_ACCESS_READY;

	/* ꂩĂ΁AIRQ(ƂĂ͕s\) */
	if (fdc_command & 0x0f) {
		mainetc_fdc();
		fdc_drqirq = 0x40;
	}
	else {
		fdc_drqirq = 0x00;
	}
}

/*
 *	}`ZN^
 *	Cxg
 */
static BOOL FASTCALL fdc_multi_event(void)
{
	if (fdc_drqirq & 0x10) {
		fdc_drqirq = 0x08;
		/* ZN^WX^UpAZN^ */
		fdc_secreg++;
		schedule_setevent(EVENT_FDC_M, 30, fdc_multi_event);
		return TRUE;
	}

	if (fdc_drqirq & 0x08) {
		fdc_drqirq = 0x00;
		/* ZN^ */
		if (fdc_cmdtype == 2) {
			fdc_read_data();
			fdc_drqirq |= 0x20;
		}
		if (fdc_cmdtype == 3) {
			fdc_write_data();
			fdc_drqirq |= 0x20;
		}
	}

	/* Cxg폜ďI */
	schedule_delevent(EVENT_FDC_M);
	return TRUE;
}

/*
 *	Xgf[^
 *	Cxg
 */
static BOOL FASTCALL fdc_lost_event(void)
{
	if (fdc_dataptr && (fdc_drqirq & 0x80)) {
		/* R}hł؂AXgf[^ */
		fdc_dataptr = NULL;
		fdc_status |= FDC_ST_LOSTDATA;
		fdc_status &= ~FDC_ST_DRQ;
		fdc_status &= ~FDC_ST_BUSY;
		fdc_access[fdc_drvreg] = FDC_ACCESS_READY;

		/* 荞ݔ */
		mainetc_fdc();
		fdc_drqirq = 0x40;
	}

	/* Cxg폜ďI */
	schedule_delevent(EVENT_FDC_L);
	return TRUE;
}


/*
 *	R}h
 */
static void FASTCALL fdc_process_cmd(void)
{
	BYTE high;

	high = (BYTE)(fdc_command >> 4);

#ifdef FDDSND
	/* EFCgtOݒ */
	fdc_wait = fdc_waitmode;
#endif

	/* f[^]sĂ΁A~߂ */
	fdc_dataptr = NULL;

	/*  */
	switch (high) {
		/* restore */
		case 0x00:
			fdc_restore();
			break;
		/* seek */
		case 0x01:
			fdc_seek();
			break;
		/* step */
		case 0x02:
		case 0x03:
			fdc_step();
			break;
		/* step in */
		case 0x04:
		case 0x05:
			fdc_step_in();
			break;
		/* step out */
		case 0x06:
		case 0x07:
			fdc_step_out();
			break;
		/* read data */
		case 0x08:
		case 0x09:
			fdc_read_data();
			break;
		/* write data */
		case 0x0a:
		case 0x0b:
			fdc_write_data();
			break;
		/* read address */
		case 0x0c:
			fdc_read_addr();
			break;
		/* force interrupt */
		case 0x0d:
			fdc_force_intr();
			break;
		/* read track */
		case 0x0e:
			fdc_read_track();
			break;
		/* write track */
		case 0x0f:
			fdc_write_track();
			break;
		/* ȊO */
		default:
			ASSERT(FALSE);
			break;
	}
}

/*
 *	FDC
 *	PoCgǂݏo
 */
BOOL FASTCALL fdc_readb(WORD addr, BYTE *dat)
{
#if XM7_VER >= 3
	BYTE tmp;
#endif

	switch (addr) {
		/* Xe[^XWX^ */
		case 0xfd18:
			fdc_make_stat();
			*dat = fdc_status;
			/* Xe[^X`FbN() */
			fdc_drqirq |= (BYTE)0x20;
			/* BUSY */
			if ((fdc_status & FDC_ST_BUSY) && (fdc_dataptr == NULL)) {
#ifdef FDDSND
				if (!fdc_wait && (fdc_cmdtype == 1)) {
#else
				if (fdc_cmdtype == 1) {
#endif
					/* IRQ On */
					fdc_drqirq |= (BYTE)0x40;
				}
#ifdef FDDSND
				if (!fdc_wait || (fdc_cmdtype != 1) || (fdc_drqirq & 0x40)) {
					/* BUSYtO𗎂Ƃ */
					fdc_status &= ~FDC_ST_BUSY;
					fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
				}
#else
				/* BUSYtO𗎂Ƃ */
				fdc_status &= ~FDC_ST_BUSY;
				fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
#endif
				/* xBUSY */
				return TRUE;
			}
			/* FDC荞݂AŎ~߂ */
			mfd_irq_flag = FALSE;
			fdc_drqirq &= ~0x40;
			maincpu_irq();
			return TRUE;

		/* gbNWX^ */
		case 0xfd19:
			*dat = fdc_trkreg;
			return TRUE;

		/* ZN^WX^ */
		case 0xfd1a:
			*dat = fdc_secreg;
			return TRUE;

		/* f[^WX^ */
		case 0xfd1b:
			*dat = fdc_datareg;
			/* JE^ */
			if (fdc_dataptr && (fdc_drqirq & 0x20)) {
				fdc_nowcnt++;
				/* DRQ,IRQ */
				if (fdc_nowcnt == fdc_totalcnt) {
#ifdef FDDSND
					if (fdc_wait) {
						schedule_delevent(EVENT_FDC_L);
					}
#endif
					fdc_status &= ~FDC_ST_BUSY;
					fdc_status &= ~FDC_ST_DRQ;
					fdc_drqirq &= (BYTE)~0x80;

					if ((fdc_cmdtype == 2) && (fdc_command & 0x10)) {
						/* }`ZN^ */
						fdc_status |= FDC_ST_BUSY;
						fdc_dataptr = NULL;
						fdc_drqirq = 0x10;
						schedule_setevent(EVENT_FDC_M, 30, fdc_multi_event);
						return TRUE;
					}
					/* VOZN^ */
					fdc_dataptr = NULL;
					mainetc_fdc();
					fdc_drqirq = 0x40;
					fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
					/* Read Track͕KLOST DATAAobt@C */
					if (fdc_cmdtype == 6) {
						fdc_status |= FDC_ST_LOSTDATA;
						fdc_readbuf(fdc_drvreg);
					}
				}
				else {
					fdc_datareg = fdc_dataptr[fdc_nowcnt];
#ifdef FDDSND
					if (fdc_wait) {
						schedule_setevent(EVENT_FDC_L, FDC_LOST_TIME, fdc_drq_event);
						fdc_status &= (BYTE)~FDC_ST_DRQ;
						fdc_drqirq &= (BYTE)~0x80;
					}
					else {
						fdc_drqirq |= (BYTE)0x80;
					}
#else
					fdc_drqirq |= (BYTE)0x80;
#endif
				}
			}
			return TRUE;

		/* wbhWX^ */
		case 0xfd1c:
			*dat = (BYTE)(fdc_sidereg | 0xfe);
			return TRUE;

		/* hCuWX^ */
		case 0xfd1d:
#if XM7_VER >= 3
			if (fdc_motor) {
				*dat = (BYTE)(0xbc | fdc_drvregP);
			}
			else {
				*dat = (BYTE)(0x3c | fdc_drvregP);
			}
#else
			if (fdc_motor) {
				*dat = (BYTE)(0xbc | fdc_drvreg);
			}
			else {
				*dat = (BYTE)(0x3c | fdc_drvreg);
			}
#endif
			return TRUE;

		/* [hWX^ */
		case 0xfd1e:
#if XM7_VER >= 3
			if (fm7_ver < 3) {
				*dat = 0xff;
				return TRUE;
			}

			/* _hCuEhCuΉǂݏo */
			tmp = (BYTE)(fdc_logidrv << 2) | (fdc_physdrv[fdc_logidrv]);
			/* 2DD[hǂݏo */
			if (fdc_2ddmode) {
				*dat = (BYTE)(tmp | 0xb0);
			}
			else {
				*dat = (BYTE)(tmp | 0xf0);
			}
#else
			*dat = 0xFF;
#endif
			return TRUE;

		/* DRQ,IRQ */
		case 0xfd1f:
			*dat = (BYTE)(fdc_drqirq | 0x3f);
			/* DRQ܂IRQ`FbN() */
			fdc_drqirq |= (BYTE)0x20;
			/* f[^]ŖΏI(z̐_a) */
			if (fdc_dataptr == NULL) {
#ifdef FDDSND
				if (!fdc_wait && (fdc_cmdtype == 1) && (fdc_status & FDC_ST_BUSY)) {
#else
				if ((fdc_cmdtype == 1) && (fdc_status & FDC_ST_BUSY)) {
#endif
					/* IRQ On */
					fdc_drqirq |= (BYTE)0x40;
				}
#ifdef FDDSND
				if (!fdc_wait || (fdc_cmdtype != 1) || (fdc_drqirq & 0x40)) {
					/* BUSYtO𗎂Ƃ */
					fdc_status &= ~FDC_ST_BUSY;
					fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
				}
#else
				/* BUSYtO𗎂Ƃ */
				fdc_status &= ~FDC_ST_BUSY;
				fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
#endif
			}
			return TRUE;
	}

	return FALSE;
}

/*
 *	FDC
 *	PoCg
 */
BOOL FASTCALL fdc_writeb(WORD addr, BYTE dat)
{
#if XM7_VER >= 3
	BOOL tmp;
#endif

	switch (addr) {
		/* R}hWX^ */
		case 0xfd18:
#if XM7_VER >= 2
			if (fm7_ver >= 2) {
				fdc_dsenable = 0x00;	/* R}hsDS ENABLEԂƂ */
			}
#endif
			fdc_command = dat;
			fdc_process_cmd();
			return TRUE;

		/* gbNWX^ */
		case 0xfd19:
			fdc_trkreg = dat;
			/* R}hs̃gbNWX^΍ */
			/* (F-BASIC V3.3L3x/V3.4L2x VOLCOPY/SUBSET(VCOPYEB)) */
			if (((fdc_status & FDC_ST_BUSY) && (fdc_nowcnt == 0)) &&
				((fdc_cmdtype == 2) || (fdc_cmdtype == 3))) {
				fdc_process_cmd();
			}
			return TRUE;

		/* ZN^WX^ */
		case 0xfd1a:
			fdc_secreg = dat;
			/* R}hs̃ZN^WX^΍ */
			/* (F-BASIC V3.3L3x/V3.4L2x VOLCOPY/SUBSET(VCOPYEB)) */
			if (((fdc_status & FDC_ST_BUSY) && (fdc_nowcnt == 0)) &&
				((fdc_cmdtype == 2) || (fdc_cmdtype == 3))) {
				fdc_process_cmd();
			}
			return TRUE;

		/* f[^WX^ */
		case 0xfd1b:
			fdc_datareg = dat;
			/* JE^ */
			if (fdc_dataptr && (fdc_drqirq & 0x20)) {
				fdc_dataptr[fdc_nowcnt] = fdc_datareg;
				fdc_nowcnt++;
				/* DRQ,IRQ */
				if (fdc_nowcnt == fdc_totalcnt) {
#ifdef FDDSND
					if (fdc_wait) {
						schedule_delevent(EVENT_FDC_L);
					}
#endif
					fdc_status &= ~FDC_ST_DRQ;
					fdc_drqirq &= (BYTE)(~0x80);
					fdc_status &= ~FDC_ST_BUSY;

					if (fdc_cmdtype == 3) {
						if (!fdc_writesec()) {
							fdc_status |= FDC_ST_WRITEFAULT;
						}
					}
					if (fdc_cmdtype == 5) {
						if (!fdc_writetrk()) {
							fdc_status |= FDC_ST_WRITEFAULT;
						}
						/* tH[}bĝߎgpobt@C */
						fdc_readbuf(fdc_drvreg);
					}
					if ((fdc_cmdtype == 3) && (fdc_command & 0x10)) {
						/* }`ZN^ */
						fdc_status |= FDC_ST_BUSY;
						fdc_dataptr = NULL;
						fdc_drqirq = 0x10;
						schedule_setevent(EVENT_FDC_M, 30, fdc_multi_event);
						return TRUE;
					}
					fdc_dataptr = NULL;
					mainetc_fdc();
					fdc_drqirq = 0x40;
					fdc_access[fdc_drvreg] = FDC_ACCESS_READY;
				}
				else {
#ifdef FDDSND
					if (fdc_wait) {
						schedule_setevent(EVENT_FDC_L, FDC_LOST_TIME, fdc_drq_event);
						fdc_status &= (BYTE)~FDC_ST_DRQ;
						fdc_drqirq &= (BYTE)~0x80;
					}
					else {
						fdc_drqirq |= (BYTE)0x80;
					}
#else
					fdc_drqirq |= (BYTE)0x80;
#endif
				}
			}
			return TRUE;

		/* wbhWX^ */
		case 0xfd1c:
			if ((dat & 0x01) != fdc_sidereg) {
				fdc_sidereg = (BYTE)(dat & 0x01);
				fdc_readbuf(fdc_drvreg);
			}
			return TRUE;

		/* hCuWX^ */
		case 0xfd1d:
			/* hCuύXȂAfdc_readbuf */
#if XM7_VER >= 3
			if (fdc_drvregP != (dat & 0x03)) {
				fdc_drvregP = (BYTE)(dat & 0x03);
				fdc_drvreg = (BYTE)fdc_physdrv[fdc_drvregP];
				fdc_readbuf(fdc_drvreg);
			}
#else
			if (fdc_drvreg != (dat & 0x03)) {
				fdc_drvreg = (BYTE)(dat & 0x03);
				fdc_readbuf(fdc_drvreg);
			}
#endif
			fdc_motor = (BYTE)(dat & 0x80);
			/* hCuȂA[^~߂ */
			if (fdc_drvreg >= FDC_DRIVES) {
				fdc_motor = 0;
			}

#if XM7_VER >= 2
			/* DS ENABLE͋L̂(ۂɎgpɂ͋@ˑ̑ΉKv) */
			if (fm7_ver >= 2) {
				fdc_dsenable = (BYTE)(dat & 0x40);
			}
#endif
			return TRUE;

		/* [hWX^ */
		case 0xfd1e:
#if XM7_VER >= 3
			if (fm7_ver < 3) {
				return TRUE;
			}

			/* 2DD؂芷 */
			tmp = fdc_2ddmode;

			if (dat & 0x40) {
				fdc_2ddmode = FALSE;
			}
			else {
				fdc_2ddmode = TRUE;
			}

			/* _hCuƕhCȗΉύX */
			fdc_logidrv = (BYTE)((dat & 0x0c) >> 2);
			if (dat & 0x10) {
				/*  */
				fdc_physdrv[fdc_logidrv] = (BYTE)(dat & 0x03);

				/* JghCu̐ݒ肪ύXꂽꍇ̏ */
				if (fdc_logidrv == fdc_drvregP) {
					fdc_drvreg = (BYTE)fdc_physdrv[fdc_logidrv];
					fdc_readbuf(fdc_drvreg);
					return TRUE;
				}
			}

			/* 2DD؂芷sꂽꍇ͍ēǂݍ */
			if (fdc_2ddmode != tmp) {
				fdc_readbuf(fdc_drvreg);
			}
#endif
			return TRUE;
	}

	return FALSE;
}

/*
 *	FDC
 *	Z[u
 */
BOOL FASTCALL fdc_save(int fileh)
{
	int i;

	/* t@C֌WɎĂ */
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_write(fileh, fdc_ready[i])) {
			return FALSE;
		}
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_write(fileh, (BYTE*)fdc_fname[i], 256 + 1)) {
			return FALSE;
		}
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_write(fileh, fdc_media[i])) {
			return FALSE;
		}
	}

	/* Ver4g */
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_bool_write(fileh, fdc_teject[i])) {
			return FALSE;
		}
	}

	/* t@CXe[^X */
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_write(fileh, fdc_track[i])) {
			return FALSE;
		}
	}
	if (!file_write(fileh, fdc_buffer, 0x2000)) {
		return FALSE;
	}

	/* fdc_dataptr͊Ɉˑf[^|C^ */
	if (!fdc_dataptr) {
		if (!file_word_write(fileh, 0x2000)) {
			return FALSE;
		}
	}
	else {
		if (!file_word_write(fileh, (WORD)(fdc_dataptr - &fdc_buffer[0]))) {
			return FALSE;
		}
	}

	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_dword_write(fileh, fdc_seekofs[i])) {
			return FALSE;
		}
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_dword_write(fileh, fdc_secofs[i])) {
			return FALSE;
		}
	}

	/* I/O */
	if (!file_byte_write(fileh, fdc_command)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_status)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_trkreg)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_secreg)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_datareg)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_sidereg)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_drvreg)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_motor)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_drqirq)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_cmdtype)) {
		return FALSE;
	}

	/* ̑ */
	if (!file_word_write(fileh, fdc_totalcnt)) {
		return FALSE;
	}
	if (!file_word_write(fileh, fdc_nowcnt)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, fdc_seekvct)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_indexcnt)) {
		return FALSE;
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_write(fileh, fdc_access[i])) {
			return FALSE;
		}
	}
	if (!file_bool_write(fileh, TRUE)) {
		return FALSE;
	}

	/* Ver9.05/7.05g */
#ifdef FDDSND
	if (!file_bool_write(fileh, fdc_wait)) {
		return FALSE;
	}
#else
	if (!file_bool_write(fileh, FALSE)) {
		return FALSE;
	}
#endif

#if XM7_VER >= 3
	/* Ver8g */
	if (!file_byte_write(fileh, fdc_2ddmode)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_logidrv)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, fdc_drvregP)) {
		return FALSE;
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_write(fileh, fdc_physdrv[i])) {
			return FALSE;
		}
	}
#endif

	if (!file_bool_write(fileh, TRUE)) {
		return FALSE;
	}
#if XM7_VER >= 2
	if (!file_byte_write(fileh, fdc_dsenable)) {
		return FALSE;
	}
#endif

	return TRUE;
}

/*
 *	FDC
 *	[h
 */
BOOL FASTCALL fdc_load(int fileh, int ver)
{
	int i;
	BYTE ready[FDC_DRIVES];
	char fname[FDC_DRIVES][256 + 1];
	BYTE media[FDC_DRIVES];
	WORD offset;
	BOOL tmp;
	int pathlen;

	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	/* t@C̍ő啶 */
#if XM7_VER >= 3
	if (((ver >= 715) && (ver <= 799)) || (ver >= 915)) {
#elif XM7_VER >= 2
	if ((ver >= 715) && (ver <= 799)) {
#else
	if ((ver >= 305) && (ver <= 499)) {
#endif
		pathlen = 256;
	}
	else {
		pathlen = 128;
	}

	/* t@C֌WɎĂ */
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_read(fileh, &ready[i])) {
			return FALSE;
		}
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_read(fileh, (BYTE*)fname[i], pathlen + 1)) {
			return FALSE;
		}
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_read(fileh, &media[i])) {
			return FALSE;
		}
	}

	/* ă}Eg݂ */
	for (i=0; i<FDC_DRIVES; i++) {
		fdc_setdisk(i, NULL);
		if (ready[i] != FDC_TYPE_NOTREADY) {
			fdc_setdisk(i, fname[i]);
			if (fdc_ready[i] != FDC_TYPE_NOTREADY) {
				if (fdc_medias[i] >= (media[i] + 1)) {
					fdc_setmedia(i, media[i]);
				}
			}
		}
	}

	/* Ver4g că`FbNӖȂł(` */
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_bool_read(fileh, &fdc_teject[i])) {
			return FALSE;
		}
	}

	/* t@CXe[^X */
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_read(fileh, &fdc_track[i])) {
			return FALSE;
		}
	}
	if (!file_read(fileh, fdc_buffer, 0x2000)) {
		return FALSE;
	}

	/* fdc_dataptr͊Ɉˑf[^|C^ */
	if (!file_word_read(fileh, &offset)) {
		return FALSE;
	}
	if (offset >= 0x2000) {
		fdc_dataptr = NULL;
	}
	else {
		fdc_dataptr = &fdc_buffer[offset];
	}

	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_dword_read(fileh, &fdc_seekofs[i])) {
			return FALSE;
		}
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_dword_read(fileh, &fdc_secofs[i])) {
			return FALSE;
		}
	}

	/* I/O */
	if (!file_byte_read(fileh, &fdc_command)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_status)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_trkreg)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_secreg)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_datareg)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_sidereg)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_drvreg)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_motor)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_drqirq)) {
		return FALSE;
	}
	if (ver < 600) {
		fdc_drqirq |= (BYTE)0x20;
	}
	if (!file_byte_read(fileh, &fdc_cmdtype)) {
		return FALSE;
	}

	/* ̑ */
	if (!file_word_read(fileh, &fdc_totalcnt)) {
		return FALSE;
	}
	if (!file_word_read(fileh, &fdc_nowcnt)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &fdc_seekvct)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &fdc_indexcnt)) {
		return FALSE;
	}
	for (i=0; i<FDC_DRIVES; i++) {
		if (!file_byte_read(fileh, &fdc_access[i])) {
			return FALSE;
		}
	}
	/* o[WƂ̌݊p(u[gtO) */
	if (!file_bool_read(fileh, &tmp)) {
		return FALSE;
	}

	/* Cxg */
	schedule_handle(EVENT_FDC_M, fdc_multi_event);
	schedule_handle(EVENT_FDC_L, fdc_lost_event);
#ifdef FDDSND
	schedule_handle(EVENT_FDD_SEEK, fdd_seek_event);
#endif
#if XM7_VER >= 3
	if ((ver >= 905) || ((ver >= 705) && (ver <= 799))) {
#elif XM7_VER >= 2
	if (ver >= 705) {
#else
	if (ver >= 300) {
#endif
		/* Ver9.05/7.05g */
#ifdef FDDSND
		if (!file_bool_read(fileh, &fdc_wait)) {
			return FALSE;
		}
		/* FDANZXEFCgLȏꍇ̓CxgnhύX */
		if (fdc_wait) {
			schedule_handle(EVENT_FDC_L, fdc_drq_event);
		}
#else
		if (!file_bool_read(fileh, &tmp)) {
			return FALSE;
		}
#endif
	}
#ifdef FDDSND
	else {
		/* EFCg[hFALSE */
		fdc_wait = FALSE;

		/* V[NCxg(zbgZbgCxg)폜 */
		schedule_delevent(EVENT_FDD_SEEK);
	}
#endif

#if XM7_VER >= 3
	/* Ver8g */
	if (ver < 800) {
		fdc_2ddmode = FALSE;
		fdc_logidrv = 0;
		fdc_drvregP = fdc_drvreg;
		/* _hCuhCuɐݒ */
		for (i=0; i<FDC_DRIVES; i++) {
			fdc_physdrv[i] = (BYTE)i;
		}
	}
	else {
		if (!file_byte_read(fileh, &fdc_2ddmode)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &fdc_logidrv)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &fdc_drvregP)) {
			return FALSE;
		}
		for (i=0; i<FDC_DRIVES; i++) {
			if (!file_byte_read(fileh, &fdc_physdrv[i])) {
				return FALSE;
			}
		}
	}
#endif

#if XM7_VER >= 3
	if (((ver >= 720) && (ver <= 799)) || (ver >= 920)) {
#elif XM7_VER >= 2
	if ((ver >= 720) && (ver <= 799)) {
#else
	if ((ver >= 310) && (ver <= 499)) {
#endif
		if (!file_bool_read(fileh, &tmp)) {
			return FALSE;
		}
	}

#if XM7_VER >= 2
#if XM7_VER >= 3
	if (((ver >= 722) && (ver <= 799)) || (ver >= 922)) {
#else
	if ((ver >= 722) && (ver <= 799)) {
#endif
		if (!file_byte_read(fileh, &fdc_dsenable)) {
			return FALSE;
		}
	}
	else {
		fdc_dsenable = 0x00;
	}
#endif

	/* XM7+ōXe[gt@CǂłȂ悤ɑ΍ */
	schedule_delevent(EVENT_FDD_MOTOR);

	return TRUE;
}
