/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ tbs[fBXN Rg[(MB8877A) ]
 */

#ifndef _fdc_h_
#define _fdc_h_

/*
 *	萔`
 */
#define FDC_DRIVES			4			/* T|[ghCu */
#define FDC_MEDIAS			16			/* D77t@CɊ܂܂ő喇 */

#define FDC_ST_BUSY			0x01		/* BUSY */
#define FDC_ST_INDEX		0x02		/* INDEXz[o */
#define FDC_ST_DRQ			0x02		/* f[^v */
#define FDC_ST_TRACK00		0x04		/* gbN0 */
#define FDC_ST_LOSTDATA		0x04		/* f[^Xg */
#define FDC_ST_CRCERR		0x08		/* CRCG[ */
#define FDC_ST_SEEKERR		0x10		/* V[NG[ */
#define FDC_ST_RECNFND		0x10		/* ZN^s */
#define FDC_ST_HEADENG		0x20		/* wbht */
#define FDC_ST_RECTYPE		0x20		/* R[h^Cvُ */
#define FDC_ST_WRITEFAULT	0x20		/* ݎs */
#define FDC_ST_WRITEP		0x40		/* ݕی */
#define FDC_ST_NOTREADY		0x80		/* fBA} */

#define FDC_TYPE_NOTREADY	0			/* t@CȂ */
#define FDC_TYPE_2D			1			/* 2Dt@C}Eg */
#define FDC_TYPE_D77		2			/* D77t@C}Eg */
#define FDC_TYPE_VFD		3			/* VFDt@C}Eg */
#define FDC_TYPE_2DD		4			/* 2DDt@C}Eg */

#define FDC_ACCESS_READY	0			/* ANZXȂ */
#define FDC_ACCESS_SEEK		1			/* V[NnANZX */
#define FDC_ACCESS_READ		2			/* ǂݍ݌nANZX */
#define FDC_ACCESS_WRITE	3			/* ݌nANZX */
#define FDC_ACCESS_NOTREADY	4			/* hCȕłĂȂ */

#define FDC_LOST_TIME		48			/* waitLOST DATA܂ł̎ */

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL fdc_init(void);
										/*  */
void FASTCALL fdc_cleanup(void);
										/* N[Abv */
void FASTCALL fdc_reset(void);
										/* Zbg */
BOOL FASTCALL fdc_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL fdc_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL fdc_save(int fileh);
										/* Z[u */
BOOL FASTCALL fdc_load(int fileh, int ver);
										/* [h */
int FASTCALL fdc_setdisk(int drive, char *fname);
										/* fBXNZbg */
BOOL FASTCALL fdc_setmedia(int drive, int index);
										/* fBXNt@CfBAw */
BOOL FASTCALL fdc_setwritep(int drive, BOOL writep);
										/* CgveNgw */

/*
 *	v[N
 */
extern BYTE fdc_command;
										/* $FD18 FDCR}h */
extern BYTE fdc_status;
										/* $FD18 FDCXe[^X */
extern BYTE fdc_trkreg;
										/* $FD19 gbNWX^ */
extern BYTE fdc_secreg;
										/* $FD1A ZN^WX^ */
extern BYTE fdc_datareg;
										/* $FD1B f[^WX^ */
extern BYTE fdc_sidereg;
										/* $FD1C TChWX^ */
extern BYTE fdc_motor;
										/* $FD1D [^(on:0x80 off:0x00) */
extern BYTE fdc_drvreg;
										/* $FD1D hCu(0-3) */
extern BYTE fdc_drqirq;
										/* $FD1F DRQ, IRQ, ̑tO */

#if XM7_VER >= 2
extern BYTE fdc_dsenable;
										/*($FD1D)DSCl[u */
#endif

#if XM7_VER >= 3
extern BYTE fdc_drvregP;
										/*($FD1D)hCuԍ */
extern BYTE fdc_logidrv;
										/* $FD1E _hCuԍ */
extern BYTE fdc_physdrv[FDC_DRIVES];
										/* $FD1E _/hCȗΉ */
extern BYTE fdc_2ddmode;
										/* $FD1E 2DD[hZNg */
#endif

extern BYTE fdc_cmdtype;
										/* R}h^Cv */
extern WORD fdc_totalcnt;
										/* g[^JE^ */
extern WORD fdc_nowcnt;
										/* JgJE^ */
extern BYTE fdc_ready[FDC_DRIVES];
										/* fB */
extern BOOL fdc_teject[FDC_DRIVES];
										/* ꎞCWFNg */
extern BOOL fdc_writep[FDC_DRIVES];
										/* ݋֎~ */
extern BYTE fdc_track[FDC_DRIVES];
										/* gbN */

extern char fdc_fname[FDC_DRIVES][256+1];
										/* t@Cl[ */
extern char fdc_name[FDC_DRIVES][FDC_MEDIAS][17];
										/* fBAƂ̖O */
extern BOOL fdc_fwritep[FDC_DRIVES];
										/* ݋֎~(t@CP) */
extern BYTE fdc_header[FDC_DRIVES][0x2b0];
										/* D77t@Cwb_ */
extern BYTE fdc_medias[FDC_DRIVES];
										/* fBA */
extern BYTE fdc_media[FDC_DRIVES];
										/* fBAZNg */
extern BYTE fdc_access[FDC_DRIVES];
										/* ANZXLED */

#ifdef FDDSND
extern BOOL fdc_waitmode;
										/* FDCANZXEFCg */
extern BOOL fdc_sound;
										/* FDDV[NtO */
#endif

#ifdef __cplusplus
}
#endif

#endif	/* _fdc_h_ */
